//
// Created:     05.09.06
// Aurthor:    Iain Gilbert
//
// Updated:		08.11.09 
// Scripters:	GhostTT & ZiGGi

#if defined _account_included
#endinput
#endif

#define _account_included
#pragma library account
#include "base"

#define AccountRegDialogid 0
#define AccountLogDialogid 1

forward AccountLoadConfig();
forward AccountSaveConfig();
forward AccountSave(playerid);
forward AccountLogin(playerid,password[]);
forward AccountCommandHandler(playerid,text[]);

forward AccountRegister(playerid,password[]);
forward AccountConnect(playerid);
forward AccountDialog(playerid,dialogid,response,listitem,inputtext[]);

new AccountDB[MAX_STRING] = "GTO/Account/";
new PlayerEmail[MAX_PLAYERS][MAX_NAME];
new PlayerPassword[MAX_PLAYERS][MAX_NAME];
new PlayerCreationDate[MAX_PLAYERS];
new PlayerRegistered[MAX_PLAYERS];
new City[MAX_PLAYERS];

public AccountLoadConfig()
{
	if(!dini_Exists(ConfigDB)) return 1;
	new temp[MAX_STRING];
	set(temp,dini_Get(ConfigDB,"Account_DB"));
	if(strlen(temp) > 0) set(AccountDB,temp);
	set(temp,nullstr);
	return 1;
}

public AccountSaveConfig()
{
	if(!dini_Exists(ConfigDB)) return 1;
	dini_Set(ConfigDB,"Account_DB",AccountDB);
	return 1;
}

public AccountSave(playerid)
{
	if(!IsPlayerRegistered(playerid)) return 0;
	account_save_db_dini(playerid);
	return 1;
}

account_save_db_dini(playerid)
{
	new dinifilename[MAX_STRING];
	format(dinifilename,sizeof(dinifilename),"%s%s.txt",AccountDB,oGetPlayerName(playerid));
	if (!dini_Exists(dinifilename))
	{
		dini_Create(dinifilename);
	}
	new temp[MAX_STRING];
	dini_Set(dinifilename,"Name",oGetPlayerName(playerid));
	dini_Set(dinifilename,"Password",PlayerPassword[playerid]);
	dini_Set(dinifilename,"Email",PlayerEmail[playerid]);
	valstr(temp,PlayerCreationDate[playerid]);
	dini_Set(dinifilename,"Creation_Date",temp);
	new day,month,year,seconds,minutes,hours;
	gettime(hours,minutes,seconds);
	getdate(year,month,day);
	format(temp,sizeof(temp),"%d:%02d,sss %d.%02d.%d",hours,minutes,day,month,year);
	dini_Set(dinifilename,"Last_Login",temp);
}

public AccountLogin(playerid,password[])
{
	new string[MAX_STRING],logstring[MAX_STRING];
	if(PlayerRegistered[playerid])
	{
		SendClientMessage(playerid,COLOUR_RED,lang_texts[1][1]);
		return false;
	}
	if(account_login_db_dini(playerid,password) == 0) return 0;
	PlayerLoadStats(playerid);
	GivePlayerOwnedWeapons(playerid);
	if(IsPlayerAdmin(playerid))
	{
		format(string,sizeof(string),"~w~Welcome ~n~~b~RCON Admin ~n~~y~%s",oGetPlayerName(playerid));
		GameTextForPlayer(playerid,string,2000,1);
		SendClientMessage(playerid,COLOUR_GREEN, lang_texts[1][25]);
	}
	else if(IsPlayerAdm(playerid))
	{
		format(string,sizeof(string),"~w~Welcome ~n~~b~Admin ~n~~y~%s",oGetPlayerName(playerid));
		GameTextForPlayer(playerid,string,2000,1);
		SendClientMessage(playerid,COLOUR_GREEN, lang_texts[1][26]);
	}
	else if(IsPlayerMod(playerid))
	{
		format(string,sizeof(string),"~w~Welcome ~n~~g~Moderator ~n~~y~%s",oGetPlayerName(playerid));
		GameTextForPlayer(playerid,string,2000,1);
		SendClientMessage(playerid,COLOUR_GREEN, lang_texts[1][27]);
		SendDeathMessage(INACTIVE_PLAYER_ID, playerid, 200);
	}
	else
	{
		format(string,sizeof(string),"~w~Welcome ~n~~y~%s",oGetPlayerName(playerid));
		GameTextForPlayer(playerid,string,2000,1);
		SendClientMessage(playerid,COLOUR_GREEN, lang_texts[1][2]);
		SendDeathMessage(INACTIVE_PLAYER_ID, playerid, 200);
	}
	for(new idst;idst<MAX_PLAYERS;idst++)
	{
		if(IsPlayerConnected(idst))
		{
			if(IsPlayerAdmin(idst))
			{
				format(string,sizeof(string), lang_texts[1][17] ,oGetPlayerName(playerid),playerid);
				SendPlayerFormattedText(idst,string, 0,COLOUR_WHITE);
				new Float:playerx,Float:playery,Float:playerz;
				GetPlayerPos(idst,playerx,playery,playerz);
				PlayerPlaySound(idst,1150,playerx,playery,playerz);
			}
		}
	}
	format(logstring, sizeof (logstring), "player: %d:  %s: logged in successfully [%s]",playerid,oGetPlayerName(playerid),string);
	WriteLog(logstring);
	return true;
}

account_login_db_dini(playerid,password[])
{
	new dinifilename[MAX_STRING];
	format(dinifilename,sizeof(dinifilename),"%s%s.txt",AccountDB,oGetPlayerName(playerid));
	new dbpassword[MAX_NAME];
	if(dini_Exists(dinifilename))
	{
		set(dbpassword,dini_Get(dinifilename,"Password"));
		if(!equal(password,dbpassword,false))
		{
			new logstring[256];
			format(logstring, sizeof (logstring), "player_login: failed: incorrect password ID:%d NAME:%s :",playerid,oGetPlayerName(playerid));
			WriteLog(logstring);
			SendClientMessage(playerid,COLOUR_RED,  lang_texts[1][6] );
			SendClientMessage(playerid,COLOUR_RED,  lang_texts[1][7] );
			KickPlayer(playerid,"Incorrect Password"); // kick them
			return false;
		}
		set(PlayerEmail[playerid],dini_Get(dinifilename,"Email"));
		set(PlayerCreationDate[playerid],dini_Get(dinifilename,"Creation_Date"));
		set(PlayerPassword[playerid],dbpassword);
		PlayerRegistered[playerid] = 1;
		new temp[255];
		new day,month,year,seconds,minutes,hours;
		gettime(hours,minutes,seconds);
		getdate(year,month,day);
		format(temp,sizeof(temp),"%d:%02d,%d.%02d.%d",hours,minutes,day,month,year);
		dini_Set(dinifilename,"Last_Login",temp);
	}
	else
	{
		set(PlayerEmail[playerid],dini_Get(dinifilename,"Email"));
		set(PlayerCreationDate[playerid],dini_Get(dinifilename,"Creation_Date"));
		set(PlayerPassword[playerid],dbpassword);
		PlayerRegistered[playerid] = 1;
	}
	return true;
}

public AccountCommandHandler(playerid,text[]) // process account commands
{
	if(!IsPlayerConnected(playerid)) return 0;
	new cmd[20],idx;
	set(cmd,strcharsplit(text, idx,strchar(" ")));
	if(!strcmp(cmd,"/register"))
	{
		new password[MAX_NAME],email[MAX_NAME],dinifilename[MAX_STRING],temp[MAX_STRING],logstring[MAX_STRING];
		set(password,strcharsplit(text, idx,strchar(" "))); 
		set(email,strcharsplit(text, idx,strchar(" ")));
		if(strfind(email,charstr(DBSeperator),false) != -1)
		{
			format(logstring, sizeof (logstring), "%s: register_account: fail: DB seperator found in email",oGetPlayerName(playerid));
			WriteLog(logstring);
			SendClientMessage(playerid, COLOUR_MISC, lang_texts[1][8]);
			return 1;
		}
		if(!strlen(password)) return SendClientMessage(playerid, COLOUR_MISC, lang_texts[1][9]);
		if(PlayerRegistered[playerid]) return SendClientMessage(playerid,COLOUR_RED, lang_texts[1][10]);
		format(dinifilename,sizeof(dinifilename),"%s%s.txt",AccountDB,oGetPlayerName(playerid));
		if(dini_Exists(dinifilename)) return SendClientMessage(playerid,COLOUR_RED, lang_texts[1][11]);
		dini_Create(dinifilename);
		dini_Set(dinifilename,"Name",oGetPlayerName(playerid));
		set(temp,password);
		dini_Set(dinifilename,"Password",temp);
		dini_Set(dinifilename,"Email",email);
		valstr(temp,Now());
		dini_Set(dinifilename,"Creation_Date",temp);
		valstr(temp,Now());
		dini_Set(dinifilename,"Last_Login",temp);
		CreatePlayer(playerid);
		SendClientMessage(playerid,COLOUR_GREEN, lang_texts[1][12]);
		AccountLogin(playerid,password);
		format(logstring,sizeof(logstring), "create_account: success %d  %s",playerid,oGetPlayerName(playerid));
		WriteLog(logstring);
		return 1;
	}
	if(!strcmp(cmd,"/login"))
	{
		new password[MAX_STRING];
		set(password,strcharsplit(text, idx,strchar(" "))); 
		if(!strlen(password)) return SendClientMessage(playerid, COLOUR_MISC, lang_texts[1][13]);
		AccountLogin(playerid,password);
		return 1;
	}
	if(!strcmp(cmd,"/changepass"))
	{
		if(GetPlayerMoney(playerid) < 500000)
		{
			SendClientMessage(playerid,COLOUR_WHITE,lang_texts[1][35]);
			return 1;
		}
		new password[256],string[256];
		set(password,strcharsplit(text, idx,strchar(" ")));
		set(PlayerPassword[playerid],password);
		format(string,sizeof(string),lang_texts[1][34],password);
		SendClientMessage(playerid,COLOUR_WHITE,string);
		oGivePlayerMoney(playerid,-500000,1);
		return 1;
	}
	if(!strcmp(cmd,"/savechar"))
	{
		if(!IsPlayerRegistered(playerid)) return 1;
		PlayerSave(playerid);
		AccountSave(playerid);
		return 1;
	}
	return 0;
}

public AccountRegister(playerid,password[])
{	
	new temp[MAX_STRING],ghostttfile[MAX_STRING],hou,sec,year,mont,day;
	new logstring[MAX_STRING],email[40];
	new mins;
	format(ghostttfile,sizeof(ghostttfile),"%s%s.txt",AccountDB,oGetPlayerName(playerid));
	dini_Create(ghostttfile);
	dini_Set(ghostttfile,"Name",oGetPlayerName(playerid));
	dini_Set(ghostttfile,"Password",password);
	format(email,sizeof(email),"admin@sa-mp.com");
	dini_Set(ghostttfile,"Email",email);
	gettime(hou,mins,sec);
	getdate(year,mont,day);
	format(temp,sizeof(temp),"%d.%02d.%d, %d:%02d",day,mont,year,hou,mins);
	dini_Set(ghostttfile,"Creation_Date",temp);
	valstr(temp,Now());
	dini_Set(ghostttfile,"Last_Login",temp);
	CreatePlayer(playerid);
	SendClientMessage(playerid,COLOUR_GREEN, lang_texts[1][12]);
	AccountLogin(playerid,password);
	format(logstring,sizeof(logstring),"create_account: success %d  %s",playerid,oGetPlayerName(playerid));
	WriteLog(logstring);
	return 1;
}

public AccountConnect(playerid)
{
	if(IsPlayerNPC(playerid)) return 1;
	new dinifile[MAX_STRING],message[MAX_STRING];
	format(dinifile,sizeof(dinifile),"%s%s.txt",AccountDB,oGetPlayerName(playerid));
	if(dini_Exists(dinifile))
	{
 		format(message,sizeof(message),", %s!\n\n   !",oGetPlayerName(playerid));
	    ShowPlayerDialog(playerid,1,DIALOG_STYLE_INPUT,"  ",message,"Login","Cancel");
	}
	else
	{
	    format(message,sizeof(message),", %s!\n\n   !",oGetPlayerName(playerid));
		ShowPlayerDialog(playerid,0,DIALOG_STYLE_INPUT,"",message,"Register","Cancel");
	}
	City[playerid] = random(3);
	return 1;
}

public AccountDialog(playerid,dialogid,response,listitem,inputtext[])
{
	if(dialogid == AccountRegDialogid)
	{
		if(!response) return AccountConnect(playerid);
		if(strlen(inputtext) > 0) return AccountRegister(playerid,inputtext);
		else AccountConnect(playerid);
	}
	if(dialogid == AccountLogDialogid)
	{
		if(!response) AccountConnect(playerid);
		if(strlen(inputtext) > 0) AccountLogin(playerid,inputtext);
		else AccountConnect(playerid);
	}
	return 1;
}
