//
// Created:     17.09.06
// Aurthor:    Iain Gilbert
//


#if defined _bank_included
#endinput
#endif

#define _bank_included
#pragma library bank
#include "base"
#include "player"

forward BankInit();
forward BankPickUp(playerid,pickupid);
forward IsPlayerAtBank(playerid);
forward BankCommandHandler(playerid,text[]);
forward BankDialog(playerid,dialogid,response,listitem,inputtext[]);

#define MAX_BANK 15000000
#define BanksCount 4
#define BankDialogid 5

new Banks[BanksCount][CoordInfo] = {
	{-22.9578,-54.8951,1003.5469}, // LV 24/7 bank
	{371.2316,-125.5778,1001.4995}, // LS pizza bank
	{368.7201,-72.7097,1001.5078}, // LS burger bank7
	{364.9761,-8.5396,1001.8516} // LS chicken bank5
};

new BankPickup[BanksCount];

public BankInit()
{
	for(new bankid;bankid<BanksCount;bankid++)
	{
	    BankPickup[bankid] = CreatePickup(1274, 23, Banks[bankid][Coord_X],Banks[bankid][Coord_Y],Banks[bankid][Coord_Z], 0);
	}
}

public IsPlayerAtBank(playerid)
{
	for(new bankid;bankid<BanksCount;bankid++)
	{
		if(IsPlayerInRangeOfPoint(playerid,5,Banks[bankid][Coord_X],Banks[bankid][Coord_Y],Banks[bankid][Coord_Z])) return 1;
	}
	return 0;
}

public BankPickUp(playerid, pickupid)
{
	for(new bankid;bankid<BanksCount;bankid++)
    {
        if(pickupid == BankPickup[bankid])
        {
			if(PlayerDialog[playerid] == 0)
			{
				SendPlayerFormattedText(playerid,lang_texts[2][1],0,COLOUR_GREEN);
				SendPlayerFormattedText(playerid,lang_texts[2][2],Player[playerid][Bank],COLOUR_GREEN);
				ShowPlayerDialog(playerid,BankDialogid,DIALOG_STYLE_INPUT,"","    \n    ","","");
				PlayerDialog[playerid] = 1;
			}
        }
    }
	return 1;
}

public BankCommandHandler(playerid,text[]) // process player commands
{
	if(!IsPlayerConnected(playerid)) return 0;
	new cmd[20],idx;

	set(cmd,strcharsplit(text, idx,strchar(" ")));
	if(strlen(cmd) == 0) return 0;

	if(!strcmp(cmd, "/withdraw"))
	{
		if(!IsPlayerAtBank(playerid)) return SendClientMessage(playerid,COLOUR_RED, lang_texts[2][3]);
		set(cmd,strcharsplit(text, idx,strchar(" ")));
		if(strlen(cmd) == 0) return SendClientMessage(playerid,COLOUR_RED, lang_texts[2][4]);
		new amount = strval(cmd);
		if(amount <= 0) return SendClientMessage(playerid,COLOUR_RED, lang_texts[2][5]);
		if(amount > Player[playerid][Bank]) amount = Player[playerid][Bank];

		oGivePlayerMoney(playerid,amount,0);
		Player[playerid][Bank] = Player[playerid][Bank] - amount;
		new string[MAX_STRING];
		format(string,sizeof(string), lang_texts[2][6],amount,Player[playerid][Bank]);
		SendPlayerFormattedText(playerid, string,0,COLOUR_GREEN);
		new Float:playerx,Float:playery,Float:playerz;
		GetPlayerPos(playerid,playerx,playery,playerz);
		PlayerPlaySound(playerid,1084,playerx,playery,playerz);

		new logstring[MAX_STRING];
		format(logstring, sizeof (logstring), "player: %d:  %s: withdrawed $%d from the bank. Current balance: $%d ",playerid,oGetPlayerName(playerid),amount,Player[playerid][Bank]);
		WriteLog(logstring);
		return 1;
	}

	if((!strcmp(cmd, "/bank")) || (!strcmp(cmd, "/deposit")))
	{
		if(!IsPlayerAtBank(playerid)) return SendClientMessage(playerid,COLOUR_RED, lang_texts[2][7]);
		set(cmd,strcharsplit(text, idx,strchar(" ")));
		if(strlen(cmd) == 0) return SendClientMessage(playerid,COLOUR_RED, lang_texts[2][8]);
		new amount = strval(cmd);
		if(amount <= 0) return SendClientMessage(playerid,COLOUR_RED, lang_texts[2][9]);
		if(oGetPlayerMoney(playerid) < amount) amount = oGetPlayerMoney(playerid);
		if(Player[playerid][Bank] + amount > MAX_BANK) amount = MAX_BANK - Player[playerid][Bank];
		oGivePlayerMoney(playerid,-amount,0);
		Player[playerid][Bank] += amount;
		new string[MAX_STRING];
		format(string,sizeof(string), lang_texts[2][10],amount,Player[playerid][Bank]);
		SendPlayerFormattedText(playerid, string,0,COLOUR_GREEN);
		new Float:playerx,Float:playery,Float:playerz;
		GetPlayerPos(playerid,playerx,playery,playerz);
		PlayerPlaySound(playerid,1083,playerx,playery,playerz);

		new logstring[MAX_STRING];
		format(logstring, sizeof (logstring), "player: %d:  %s: deposited $%d at the bank. Current balance: $%d ",playerid,oGetPlayerName(playerid),amount,Player[playerid][Bank]);
		WriteLog(logstring);

		if(Player[playerid][Bank] == MAX_BANK)
		{
			SendPlayerFormattedText(playerid,  lang_texts[2][11]  , 0,COLOUR_RED);
			set(logstring,nullstr);
			format(logstring, sizeof (logstring), "player: %d:  %s: His bank is full",playerid,oGetPlayerName(playerid));
			WriteLog(logstring);
		}
		return 1;
	}
	return 0;
}

public BankDialog(playerid,dialogid,response,listitem,inputtext[])
{
	if(dialogid == BankDialogid)
	{
		if(!isNumeric(inputtext) || strlen(inputtext) <= 0){
		SendClientMessage(playerid,COLOUR_RED,"   ");
		PlayerDialog[playerid] = 0;
		return 0;
		}
		new amount = strval(inputtext);
		if(response)
		{
			if(oGetPlayerMoney(playerid) < amount) amount = oGetPlayerMoney(playerid);
			if(Player[playerid][Bank] + amount > MAX_BANK) amount = MAX_BANK - Player[playerid][Bank];
			oGivePlayerMoney(playerid,-amount,0);
			Player[playerid][Bank] += amount;
			new string[MAX_STRING];
			format(string,sizeof(string), lang_texts[2][10],amount,Player[playerid][Bank]);
			SendPlayerFormattedText(playerid, string,0,COLOUR_GREEN);
			new Float:playerx,Float:playery,Float:playerz;
			GetPlayerPos(playerid,playerx,playery,playerz);
			PlayerPlaySound(playerid,1083,playerx,playery,playerz);
			PlayerDialog[playerid] = 0;
		}
		else
		{
			if(amount > Player[playerid][Bank]) amount = Player[playerid][Bank];
			oGivePlayerMoney(playerid,amount,0);
			Player[playerid][Bank] = Player[playerid][Bank] - amount;
			new string[MAX_STRING];
			format(string,sizeof(string), lang_texts[2][6],amount,Player[playerid][Bank]);
			SendPlayerFormattedText(playerid, string,0,COLOUR_GREEN);
			new Float:playerx,Float:playery,Float:playerz;
			GetPlayerPos(playerid,playerx,playery,playerz);
			PlayerPlaySound(playerid,1084,playerx,playery,playerz);
			PlayerDialog[playerid] = 0;
		}
	}
	return 1;
}
