//
// Created:     13.09.06
// Aurthor:    Iain Gilbert
//

#if defined _groundhold_included
#endinput
#endif

#define _groundhold_included
#pragma library groundhold
#include "base"
#include "player"
#include "world"

forward GroundholdInit();
forward CheckGround(ghid);
forward CountPlayers(players[]);
forward CheckAllGround();

#define GROUNDHOLD_DELAY 5000 // how often in seconds players are paid
#define GROUNDHOLD_SIZE 3

enum gh_info 
{
	gh_name[MAX_NAME], // name of ground
	gh_money, // base amount of money recieved for holding this ground
	gh_xp, // base amount of xp recieved for holding this ground
	gh_multi, // max multiplyer of base
	gh_dist, // distance from checkpoint player can be to still receive pay
	Float:gh_x,
	Float:gh_y,
	Float:gh_z
}

enum kach_info
{
	Float:minx,
	Float:maxx,
	Float:miny,
	Float:maxy,
}

new kach[GROUNDHOLD_SIZE][kach_info];

new PlayerGroundHoldTime[GROUNDHOLD_SIZE][MAX_PLAYERS];
new PlayerHoldingGround[GROUNDHOLD_SIZE][MAX_PLAYERS];
new groundholdActiveCPID[GROUNDHOLD_SIZE];
new groundholdCP[GROUNDHOLD_SIZE][gh_info] = {
	//      Name,       pay ,   xp multi dist,       x,          y,          z
	{" 900xp  300$",6,18,50,50,-2146.9585,-217.1571,35.3203}, // 
	{" 600xp  200$",30,10,20,30,1221.3528,-1814.8983,16.5938}, // 
	{" 300xp  100$",10,30,10,50,-687.9928,948.6489,12.1502} //  .
};

public GroundholdInit()
{
	for(new i=0;i<GROUNDHOLD_SIZE;i++)
	{
		groundholdActiveCPID[i] = AddActiveCheckpoint(groundholdCP[i][gh_x],groundholdCP[i][gh_y],groundholdCP[i][gh_z],200,2);
	}
	CreateKachZones();
	WriteLog("Groundhold checkpoints initialised");
}

public CreateKachZones(zoneid)
{
	groundholdCP[zoneid][id] = GangZoneCreate(minx,miny,maxx,maxy);
}

public CheckGround(ghid)
{
	new playergroundcount = CountPlayers(PlayerGroundHoldTime[ghid]);
	for(new playerid=0;playerid<MAX_PLAYERS;playerid++)
	{
		if(IsPlayerConnected(playerid))
		{
			/*if((oIsPlayerInCheckpoint(playerid,groundholdCP[ghid][gh_x],groundholdCP[ghid][gh_y],groundholdCP[ghid][gh_z],groundholdCP[ghid][gh_dist]))
					|| (GetDistancePlayertoXYZ(playerid,groundholdCP[ghid][gh_x],groundholdCP[ghid][gh_y],groundholdCP[ghid][gh_z]) < groundholdCP[ghid][gh_dist]))*/
			if(IsPlayerInKach(playerid,ghid))
			{
				new groundenemycount;
				for(new i=0;i<MAX_PLAYERS;i++)
				{
					if(i == playerid) continue;
					if(i == INVALID_PLAYER_ID) continue;
					//if(PlayerGroundHoldTime[ghid][i] > 0)
					if(IsPlayerInKach(i,ghid))
					{
						if(PlayerGangid[i] != PlayerGangid[playerid] && PlayerGangid[i] != 0)
						{
							groundenemycount++;
						}
					}
				}
				if(groundenemycount > 0)
				{
					GangZoneFlashForAll(ghid,color)
				}
				if(PlayerGroundHoldTime[ghid][playerid] < groundholdCP[ghid][gh_multi])
				{
					if((PlayerGroundHoldTime[ghid][playerid] == 0) && (PlayerHoldingGround[ghid][playerid] == 0))
					{
						new string[MAX_STRING];
						format(string, sizeof(string),  lang_texts[7][1] , groundholdCP[ghid][gh_name]);
						SendClientMessage(playerid, COLOUR_GREEN, string);
						new maxmoney=(groundholdCP[ghid][gh_money]*groundholdCP[ghid][gh_multi]);
						new maxxp=(groundholdCP[ghid][gh_xp]*groundholdCP[ghid][gh_multi]);
						format(string, sizeof(string),  lang_texts[7][2] ,maxmoney,maxxp);
						SendClientMessage(playerid, COLOUR_GREEN, string);
					}
					if(PlayerGroundHoldTime[ghid][playerid] == 0) PlayerGroundHoldTime[ghid][playerid]++;
					else if(groundenemycount == 0) PlayerGroundHoldTime[ghid][playerid]++;
				}
				PlayerHoldingGround[ghid][playerid] = 1;
				if(PlayerGroundHoldTime[ghid][playerid] > 0)
				{
					if(groundenemycount > 0) // if more that 0 enimies on ground
					{
						if(PlayerGroundHoldTime[ghid][playerid] > 2) // if we have been holding this ground
						{
							new string[MAX_STRING];
							format(string, sizeof(string),  lang_texts[7][3] , groundholdCP[ghid][gh_name]);
							SendClientMessage(playerid, COLOUR_RED, string);
							for(new j=0;j<MAX_PLAYERS;j++)
							{
								if(IsPlayerInKach(j,ghid) && PlayerGangid[j] != PlayerGangid[playerid])
								{
									GangZoneFlashForAll(ghid,color);
								}
							}
						}
						if(PlayerGroundHoldTime[ghid][playerid] > 1) PlayerGroundHoldTime[ghid][playerid]--;
					}
					else
					{
						GangZoneStopFlashForAll(ghid,color);
					}
					new moneyreward;
					new xpreward = (groundholdCP[ghid][gh_xp] * PlayerGroundHoldTime[ghid][playerid]);
					if(playergroundcount <= 5) moneyreward = (groundholdCP[ghid][gh_money] * PlayerGroundHoldTime[ghid][playerid]) / (1+(playergroundcount / 5));
					else moneyreward = (groundholdCP[ghid][gh_money] * PlayerGroundHoldTime[ghid][playerid]) / (1+(5 / 5));
					if(moneyreward > 0) oGivePlayerMoney(playerid,moneyreward,0);
					if(xpreward > 0 && GetPlayerXP(playerid) < MAX_LVLXP) GivePlayerXP(playerid,xpreward,0);
					else 
					{
						new string[MAX_STRING];
						format(string, sizeof(string),  lang_texts[9][17] );
						SendClientMessage(playerid, COLOUR_RED, string);
					}
				}
			}
			else 
			{
				if(PlayerGroundHoldTime[ghid][playerid] > 0)
				{
					if(PlayerHoldingGround[ghid][playerid] == 1)
					{
						new string[MAX_STRING];
						format(string, sizeof(string),  lang_texts[7][4] );
						SendClientMessage(playerid, COLOUR_RED, string);
					}
					if(PlayerGroundHoldTime[ghid][playerid] == 1)
					{
						new string[MAX_STRING];
						format(string, sizeof(string),  lang_texts[7][5] , groundholdCP[ghid][gh_name]);
						SendClientMessage(playerid, COLOUR_RED, string);
					}
					PlayerGroundHoldTime[ghid][playerid]--;
					if(PlayerGroundHoldTime[ghid][playerid] > 1)
					{
						PlayerGroundHoldTime[ghid][playerid]--;
					}
					if(PlayerGroundHoldTime[ghid][playerid] > 1) PlayerGroundHoldTime[ghid][playerid]--;
				}
				PlayerHoldingGround[ghid][playerid] = 0;
			}

		}
		else
		{
			PlayerGroundHoldTime[ghid][playerid] = 0;
			PlayerHoldingGround[ghid][playerid] = 0;
		}
	}
	return;
}

public IsPlayerInKach(playerid,ghid)
{
	new Float:x,Float:y,Float:z;
	GetPlayerPos(playerid,x,y,z);
	if(x < kach[ghid][maxx] && x > kach[ghid][minx] && y < kach[ghid][maxy] && y > kach[ghid][miny])
	{
		return true;
	}
	return false;
}

public KachUpdate()
{
	for(new i=0;i<MAX_PLAYERS;i++)
	{
		
	}
}

public CountPlayers(players[])
{
	new count;
	for(new i = 0;i<MAX_PLAYERS;i++)
	{
		if (players[i] > 0) count++;
	}
	return count;
}

public CheckAllGround()
{
	for(new ghid = 0;ghid<GROUNDHOLD_SIZE;ghid++)
	{
		CheckGround(ghid);
	}
}