//
// Created:		10.09.06
// Aurthor:		Iain Gilbert
//
#pragma tabsize 0

#include "base"
#include "player"

forward CarsCommandHandler(playerid, cmdtext[]);

#define MAX_VEHICLE_SPAWNS 2000

#define never 43200  //cars respawn time (86400 - one day)

new VehicleDoors[MAX_VEHICLE_SPAWNS];

#define V_ADMIRAL 445
#define V_ALPHA 602
#define V_AMBULAN 416
#define V_ANDROM 592			// air
#define V_ARTICT1 435
#define V_ARTICT2 450
#define V_ARTICT3 591
#define V_AT400 577				// air
#define V_BAGBOXA 606
#define V_BAGBOXB 607
#define V_BAGGAGE 485
#define V_BANDITO 568
#define V_BANSHEE 429
#define V_BARRACKS 433
#define V_BEAGLE 511			// air
#define V_BENSON 499
#define V_BF400 581				// bike
#define V_BFINJECT 424
#define V_BIKE 509				// bike
#define V_BLADE 536
#define V_BLISTAC 496
#define V_BLOODRA 504
#define V_BMX 481				// bike
#define V_BOBCAT 422
#define V_BOXBURG 609
#define V_BOXVILLE 498
#define V_BRAVURA 401
#define V_BROADWAY 575
#define V_BUCCANEE 518
#define V_BUFFALO 402
#define V_BULLET 541
#define V_BURRITO 482
#define V_BUS 431
#define V_CABBIE 438
#define V_CADDY 457
#define V_CADRONA 527
#define V_CAMPER 483
#define V_CARGOBOB 548			// air
#define V_CEMENT 524
#define V_CHEETAH 415
#define V_CLOVER 542
#define V_CLUB 589
#define V_COACH 437
#define V_COASTG 472			// water
#define V_COMBINE 532
#define V_COMET 480
#define V_COPBIKE 523			// bike
#define V_COPCARLA 596
#define V_COPCARRU 599
#define V_COPCARSF 597
#define V_COPCARVG 598
#define V_CROPDUST 512			// air
#define V_DFT30 578
#define V_DINGHY 473			// water
#define V_DODO 593				// air
#define V_DOZER 486
#define V_DUMPER 406
#define V_DUNERIDE 573
#define V_ELEGANT 507
#define V_ELEGY 562
#define V_EMPEROR 585
#define V_ENFORCER 427
#define V_ESPERANT 419
#define V_EUROS 587
#define V_FAGGIO 462
#define V_FARMTR1 610
#define V_FBIRANCH 490
#define V_FBITRUCK 528
#define V_FCR900 521			// bike
#define V_FELTZER 533
#define V_FIRELA 544
#define V_FIRETRUK 407
#define V_FLASH 565
#define V_FLATBED 455
#define V_FORKLIFT 530
#define V_FORTUNE 526
#define V_FREEWAY 463			// bike
#define V_FREIBOX 590			//vagon
#define V_FREIFLAT 569			//vagon
#define V_FREIGHT 537			//POEZD
#define V_GLENDALE 466
#define V_GLENSHIT 604
#define V_GREENWOO 492
#define V_HERMES 474
#define V_HOTDOG 588
#define V_HOTKNIFE 434
#define V_HOTRINA 502
#define V_HOTRINB 503
#define V_HOTRING 494
#define V_HUNTER 425			// air
#define V_HUNTLEY 579
#define V_HUSTLER 545
#define V_HYDRA 520				// air
#define V_INFERNUS 411
#define V_INTRUDER 546
#define V_JESTER 559
#define V_JETMAX 493			// water
#define V_JOURNEY 508
#define V_KART 571
#define V_LANDSTAL 400
#define V_LAUNCH 595			// water
#define V_LEVIATHN 417			// air
#define V_LINERUN 403
#define V_MAJESTIC 517
#define V_MANANA 410
#define V_MARQUIS 484			// water
#define V_MAVERICK 487			// air
#define V_MERIT 551
#define V_MESA 500
#define V_MONSTER 444
#define V_MONSTERA 556
#define V_MONSTERB 557
#define V_MOONBEAM 418
#define V_MOWER 572
#define V_MRWHOOP 423
#define V_MTBIKE 510			// bike
#define V_MULE 414
#define V_NEBULA 516
#define V_NEVADA 553			// air
#define V_NEWSVAN 582
#define V_NRG500 522			// bike
#define V_OCEANIC 467
#define V_PACKER 443
#define V_PATRIOT 470
#define V_PCJ600 461			// bike
#define V_PEREN 404
#define V_PETRO 514			//GRUZOVIK
#define V_PETROTR 584			//PRICEP BENZO
#define V_PHOENIX 603
#define V_PICADOR 600
#define V_PIZZABOY 448
#define V_POLMAV 497			// air
#define V_PONY 413
#define V_PREDATOR 430			// water
#define V_PREMIER 426
#define V_PREVION 436
#define V_PRIMO 547
#define V_QUAD 471				// bike
#define V_RAINDANC 563			// air
#define V_RANCHER 489
#define V_RCBANDIT 441
#define V_RCBARON 464			// air
#define V_RCCAM 594
#define V_RCGOBLIN 501			// air
#define V_RCRAIDER 465			// air
#define V_RCTIGER 564
#define V_RDTRAIN 515			//GRUZOVIK
#define V_REEFER 453			// water
#define V_REGINA 479
#define V_REMINGTN 534
#define V_RHINO 432
#define V_RNCHLURE 505
#define V_ROMERO 442
#define V_RUMPO 440
#define V_RUSTLER 476			// air
#define V_SABRE 475
#define V_SADLER 543
#define V_SADLSHIT 605
#define V_SANCHEZ 468			// bike
#define V_SANDKING 495
#define V_SAVANNA 567
#define V_SEASPAR 447			// air
#define V_SECURICA 428
#define V_SENTINEL 405
#define V_SHAMAL 519			// air
#define V_SKIMMER 460			// air
#define V_SLAMVAN 535
#define V_SOLAIR 458
#define V_SPARROW 469			// air
#define V_SPEEDER 452			// water
#define V_SQUALO 446			// water
#define V_STAFFORD 580
#define V_STALLION 439
#define V_STRATUM 561
#define V_STREAK 538
#define V_STREAKC 570
#define V_STRETCH 409
#define V_STUNT 513				// air
#define V_SULTAN 560
#define V_SUNRISE 550
#define V_SUPERGT 506
#define V_SWATVAN 601
#define V_SWEEPER 574
#define V_TAHOMA 566
#define V_TAMPA 549
#define V_TAXI 420
#define V_TOPFUN 459
#define V_TORNADO 576
#define V_TOWTRUCK 525
#define V_TRACTOR 531
#define V_TRAM 449
#define V_TRASH 408			//MUSOROVOZ
#define V_TROPIC 454			//water
#define V_TUG 583
#define V_TUGSTAIR 608			//AIRPORT LESTNICA
#define V_TURISMO 451
#define V_URANUS 558
#define V_UTILITY 552			//UBORSHIK
#define V_UTILTR1 611			//UBOESHIK PRICEP
#define V_VCNMAV 488			// air
#define V_VINCENT 540
#define V_VIRGO 491
#define V_VOODOO 412
#define V_VORTEX 539			// hovercraft PODUSHKA
#define V_WALTON 478
#define V_WASHING 421
#define V_WAYFARER 586			// bike
#define V_WILLARD 529
#define V_WINDSOR 555
#define V_YANKEE 456
#define V_YOSEMITE 554
#define V_ZR350 477

enum VehicleInfo {
	vehicle_model,
    vehicle_name[MAX_NAME],
    vehicle_nameid[MAX_NAME],
    vehicle_speed,
    vehicle_level,
    vehicle_cost
}
#define VEHICLES_SIZE 212
#define VEHICLES_START 400
new Vehicles[VEHICLES_SIZE][VehicleInfo] = {
{509,	"Bike",		"bike",		120,	1,	0},
{510,	"MountainBike",		"mtbike",		140,	1,	0},
{492,	"Greenwood",		"greenwoo",		160,	1,	10000},
{410,	"Manana",		"manana",		160,	1,	10000},
{481,	"BMX",		"bmx",		120,	1,	0},
{482,	"Burrito",		"burrito",		150,	1,	10000},
{439,	"Stallion",		"stallion",		160,	1,	10000},
{413,	"Pony",		"pony",		160,	1,	20000},
{419,	"Esperanto",		"esperant",		160,	1,	10000},
{475,	"Sabre",		"sabre",		160,	2,	20000},
{505,	"Rancher",		"rnchlure",		170,	2,	20000},
{420,	"Taxi",		"taxi",		180,	2,	20000},
{412,	"Voodoo",		"voodoo",		160,	2,	20000},
{468,	"Sanchez",		"sanchez",		190,	4,	40000},
{489,	"Rancher",		"rancher",		170,	4,	40000},
{405,	"Sentinel",		"sentinel",		165,	5,	50000},
{400,	"Landstalker",		"landstal",		160,	5,	50000},
{440,	"Rumpo",		"rumpo",		160,	5,	50000},
{436,	"Previon",		"previon",		160,	6,	60000},
{496,	"BlistaCompact",		"blistac",		200,	6,	60000},
{422,	"Bobcat",		"bobcat",		165,	6,	60000},
{416,	"Ambulance",		"ambulan",		155,	7,	70000},
{461,	"PCJ-600",		"pcj600",		190,	7,	70000},
{477,	"ZR350",		"zr350",		200,	7,	70000},
{500,	"Mesa",		"mesa",		160,	8,	80000},
{424,	"BFInjection",		"bfinject",		170,	8,	80000},
{402,	"Buffalo",		"buffalo",		200,	9,	90000},
{411,	"Infernus",		"infernus",		240,	9,	90000},
{504,	"BloodringBanger",		"bloodra",		160,	10,	100000},
{478,	"Walton",		"walton",		150,	10,	100000},
{535,	"Slamvan",		"slamvan",		160,	11,	110000},
{463,	"Freeway",		"freeway",		190,	11,	110000},
{494,	"Hotring",		"hotring",		220,	11,	110000},
{506,	"SuperGT",		"supergt",		230,	12,	120000},
{429,	"Banshee",		"banshee",		200,	12,	120000},
{451,	"Turismo",		"turismo",		240,	13,	130000},
{495,	"Sandking",		"sandking",		170,	13,	130000},
{415,	"Cheetah",		"cheetah",		230,	17,	170000},
{470,	"Patriot",		"patriot",		170,	19,	190000},

{401,	"Bravura",		"bravura",		160,	0,	0},
{403,	"Linerunner",		"linerun",		120,	0,	0},
{404,	"Pereniel",		"peren",		150,	0,	0},
{406,	"Dumper",		"dumper",		110,	0,	0},
{407,	"Firetruck",		"firetruk",		170,	0,	0},
{408,	"Trashmaster",		"trash",		110,	0,	0},
{409,	"Stretch",		"stretch",		180,	0,	0},
{414,	"Mule",		"mule",		140,	0,	0},
{417,	"Leviathan",		"leviathn",		200,	0,	0},
{418,	"Moonbeam",		"moonbeam",		150,	0,	0},
{421,	"Washington",		"washing",		180,	0,	0},
{423,	"MrWhoopee",		"mrwhoop",		145,	0,	0},
{425,	"Hunter",		"hunter",		200,	0,	0},
{426,	"Premier",		"premier",		200,	0,	0},
{427,	"Enforcer",		"enforcer",		170,	0,	0},
{428,	"Securicar",		"securica",		170,	0,	0},
{430,	"Predator",		"predator",		190,	0,	0},
{431,	"Bus",		"bus",		130,	0,	0},
{432,	"Rhino",		"rhino",		80,	0,	0},
{433,	"Barracks",		"barracks",		180,	0,	0},
{434,	"Hotknife",		"hotknife",		200,	0,	0},
{435,	"Trailer",		"artict1",		120,	0,	0},
{437,	"Coach",		"coach",		160,	0,	0},
{438,	"Cabbie",		"cabbie",		160,	0,	0},
{441,	"RCBandit",		"rcbandit",		75,	0,	0},
{442,	"Romero",		"romero",		150,	0,	0},
{443,	"Packer",		"packer",		150,	0,	0},
{444,	"Monster",		"monster",		110,	0,	0},
{445,	"Admiral",		"admiral",		165,	0,	0},
{446,	"Squalo",		"squalo",		280,	0,	0},
{447,	"Seasparrow",		"seaspar",		200,	0,	0},
{448,	"Pizzaboy",		"pizzaboy",		190,	0,	0},
{449,	"Tram",		"tram",		150,	0,	0},
{450,	"Trailer",		"artict2",		120,	0,	0},
{452,	"Speeder",		"speeder",		190,	0,	0},
{453,	"Reefer",		"reefer",		190,	0,	0},
{454,	"Tropic",		"tropic",		190,	0,	0},
{455,	"Flatbed",		"flatbed",		140,	0,	0},
{456,	"Yankee",		"yankee",		160,	0,	0},
{457,	"Caddy",		"caddy",		160,	0,	0},
{458,	"Solair",		"solair",		165,	0,	0},
{459,	"Berkley'sRCVan",		"topfun",		160,	0,	0},
{460,	"Skimmer",		"skimmer",		200,	0,	0},
{462,	"Faggio",		"faggio",		190,	0,	0},
{464,	"RCBaron",		"rcbaron",		75,	0,	0},
{465,	"RCRaider",		"rcraider",		75,	0,	0},
{466,	"Glendale",		"glendale",		160,	0,	0},
{467,	"Oceanic",		"oceanic",		160,	0,	0},
{469,	"Sparrow",		"sparrow",		200,	0,	0},
{471,	"Quad",		"quad",		160,	0,	0},
{472,	"Coastguard",		"coastg",		190,	0,	0},
{473,	"Dinghy",		"dinghy",		190,	0,	0},
{474,	"Hermes",		"hermes",		160,	0,	0},
{476,	"Rustler",		"rustler",		200,	0,	0},
{479,	"Regina",		"regina",		165,	0,	0},
{480,	"Comet",		"comet",		200,	0,	0},
{483,	"Camper",		"camper",		120,	0,	0},
{484,	"Marquis",		"marquis",		190,	0,	0},
{485,	"Baggage",		"baggage",		160,	0,	0},
{486,	"Dozer",		"dozer",		100,	0,	0},
{487,	"Maverick",		"maverick",		200,	0,	0},
{488,	"NewsChopper",		"vcnmav",		200,	0,	0},
{490,	"FBIRancher",		"fbiranch",		170,	0,	0},
{491,	"Virgo",		"virgo",		160,	0,	0},
{493,	"Jetmax",		"jetmax",		190,	0,	0},
{497,	"PoliceMaverick",		"polmav",		200,	0,	0},
{498,	"Boxville",		"boxville",		140,	0,	0},
{499,	"Benson",		"benson",		140,	0,	0},
{501,	"RCGoblin",		"rcgoblin",		75,	0,	0},
{502,	"HotringRacer",		"hotrina",		220,	0,	0},
{503,	"HotringRacer",		"hotrinb",		220,	0,	0},
{507,	"Elegant",		"elegant",		165,	0,	0},
{508,	"Journey",		"journey",		140,	0,	0},
{511,	"Beagle",		"beagle",		200,	0,	0},
{512,	"Cropdust",		"cropdust",		200,	0,	0},
{513,	"Stunt",		"stunt",		200,	0,	0},
{514,	"Trailer",		"petro",		120,	0,	0},
{515,	"RoadTrain",		"rdtrain",		120,	0,	0},
{516,	"Nebula",		"nebula",		165,	0,	0},
{517,	"Majestic",		"majestic",		165,	0,	0},
{518,	"Buccaneer",		"buccanee",		160,	0,	0},
{519,	"Shamal",		"shamal",		330,	0,	0},
{520,	"Hydra",		"hydra",		330,	0,	0},
{521,	"FCR-900",		"fcr900",		190,	0,	0},
{522,	"NRG-500",		"nrg500",		190,	0,	0},
{523,	"HPV1000",		"copbike",		190,	0,	0},
{524,	"CementTruck",		"cement",		110,	0,	0},
{525,	"TowTruck",		"towtruck",		160,	0,	0},
{526,	"Fortune",		"fortune",		160,	0,	0},
{527,	"Cadrona",		"cadrona",		160,	0,	0},
{528,	"FBITruck",		"fbitruck",		170,	0,	0},
{529,	"Willard",		"willard",		160,	0,	0},
{530,	"Forklift",		"forklift",		60,	0,	0},
{531,	"Tractor",		"tractor",		70,	0,	0},
{532,	"Combine",		"combine",		140,	0,	0},
{533,	"Feltzer",		"feltzer",		200,	0,	0},
{534,	"Remington",		"remingtn",		160,	0,	0},
{536,	"Blade",		"blade",		160,	0,	0},
{537,	"Freight",		"freight",		110,	0,	0},
{538,	"Streak",		"streak",		110,	0,	0},
{539,	"Vortex",		"vortex",		150,	0,	0},
{540,	"Vincent",		"vincent",		160,	0,	0},
{541,	"Bullet",		"bullet",		230,	0,	0},
{542,	"Clover",		"clover",		160,	0,	0},
{543,	"Sadler",		"sadler",		165,	0,	0},
{544,	"Firetruck",		"firela",		170,	0,	0},
{545,	"Hustler",		"hustler",		160,	0,	0},
{546,	"Intruder",		"intruder",		160,	0,	0},
{547,	"Primo",		"primo",		160,	0,	0},
{548,	"Cargobob",		"cargobob",		200,	0,	0},
{549,	"Tampa",		"tampa",		160,	0,	0},
{550,	"Sunrise",		"sunrise",		160,	0,	0},
{551,	"Merit",		"merit",		165,	0,	0},
{552,	"Utility",		"utility",		160,	0,	0},
{553,	"Nevada",		"nevada",		200,	0,	0},
{554,	"Yosemite",		"yosemite",		170,	0,	0},
{555,	"Windsor",		"windsor",		180,	0,	0},
{556,	"Monster",		"monstera",		110,	0,	0},
{557,	"Monster",		"monsterb",		110,	0,	0},
{558,	"Uranus",		"uranus",		200,	0,	0},
{559,	"Jester",		"jester",		200,	0,	0},
{560,	"Sultan",		"sultan",		200,	0,	0},
{561,	"Stratum",		"stratum",		200,	0,	0},
{562,	"Elegy",		"elegy",		200,	0,	0},
{563,	"Raindance",		"raindanc",		200,	0,	0},
{564,	"RCTiger",		"rctiger",		75,	0,	0},
{565,	"Flash",		"flash",		200,	0,	0},
{566,	"Tahoma",		"tahoma",		160,	0,	0},
{567,	"Savanna",		"savanna",		160,	0,	0},
{568,	"Bandito",		"bandito",		170,	0,	0},
{569,	"Freight",		"freiflat",		110,	0,	0},
{570,	"Trailer",		"streakc",		110,	0,	0},
{571,	"Kart",		"kart",		90,	0,	0},
{572,	"Mower",		"mower",		60,	0,	0},
{573,	"Duneride",		"duneride",		110,	0,	0},
{574,	"Sweeper",		"sweeper",		60,	0,	0},
{575,	"Broadway",		"broadway",		160,	0,	0},
{576,	"Tornado",		"tornado",		160,	0,	0},
{577,	"AT-400",		"at400",		200,	0,	0},
{578,	"DFT-30",		"dft30",		110,	0,	0},
{579,	"Huntley",		"huntley",		160,	0,	0},
{580,	"Stafford",		"stafford",		165,	0,	0},
{581,	"BF-400",		"bf400",		190,	0,	0},
{582,	"Newsvan",		"newsvan",		160,	0,	0},
{583,	"Tug",		"tug",		170,	0,	0},
{584,	"Trailer",		"petrotr",		120,	0,	0},
{585,	"Emperor",		"emperor",		165,	0,	0},
{586,	"Wayfarer",		"wayfarer",		190,	0,	0},
{587,	"Euros",		"euros",		200,	0,	0},
{588,	"Hotdog",		"hotdog",		140,	0,	0},
{589,	"Club",		"club",		200,	0,	0},
{590,	"Trailer",		"freibox",		110,	0,	0},
{591,	"Trailer",		"artict3",		120,	0,	0},
{592,	"Andromada",		"androm",		200,	0,	0},
{593,	"Dodo",		"dodo",		200,	0,	0},
{594,	"RCCam",		"rccam",		60,	0,	0},
{595,	"Launch",		"launch",		190,	0,	0},
{596,	"PoliceCar(LSPD)",		"copcarla",		200,	0,	0},
{597,	"PoliceCar(SFPD)",		"copcarsf",		200,	0,	0},
{598,	"PoliceCar(LVPD)",		"copcarvg",		200,	0,	0},
{599,	"PoliceRanger",		"copcarru",		160,	0,	0},
{600,	"Picador",		"picador",		165,	0,	0},
{601,	"S.W.A.T.Van",		"swatvan",		110,	0,	0},
{602,	"Alpha",		"alpha",		200,	0,	0},
{603,	"Phoenix",		"phoenix",		200,	0,	0},
{604,	"Glendale",		"glenshit",		160,	0,	0},
{605,	"Sadler",		"sadlshit",		165,	0,	0},
{606,	"LuggageTrailer",		"bagboxa",		160,	0,	0},
{607,	"LuggageTrailer",		"bagboxb",		160,	0,	0},
{608,	"StairTrailer",		"tugstair",		160,	0,	0},
{609,	"Boxbville",		"boxburg",		140,	0,	0},
{610,	"FarmPlow",		"farmtr1",		160,	0,	0},
{611,	"UtilityTrailer",		"utiltr1",		160,	0,	0}
};


//-------------------------------------------------------------------------------------------
// Vehicle Spawns

enum VehicleSpawnInfo {
	vspawn_model, 			 // Model
	Float:vspawn_x,         // X
	Float:vspawn_y,         // Y
	Float:vspawn_z,         // Z
	Float:vspawn_heading,   // Heading
    vspawn_colour1,         // Colour1
    vspawn_colour2          // Colour2

}

// these vehicles will be spawned first, so if you wish to reserve a vehicle model, add it here
new VehicleModelSpawns[][VehicleSpawnInfo] = {
	{V_BUFFALO,1586.4277,33.1434,23.0000,274.2331,-1,-1}, // race riversiderun car
	{V_PCJ600,1587.8152,25.9319,22.7000,270.2577,-1,-1}, // race riversiderun car
	{V_SABRE,1514.2000,11.2897,23.8677,283.6043,-1,-1}, // race riversiderun car
	{V_BANSHEE,1544.4312,14.6398,23.8626,283.2028,-1,-1}, // race riversiderun car
	{V_YOSEMITE,1423.4043,222.6558,19.2835,334.9312,-1,-1}, // town9
	{V_MONSTER,1446.4843,369.7041,18.6943,72.6925,-1,-1}, // monster
	{V_BUFFALO,316.6555,-52.1035,1.5781,166.4684,-1,-1}, // town8

	{V_MONSTER,2415.2097, 121.2115, 26.8478, 268.1243, 24,123}, // monster

	{V_MONSTER,1932.2471,176.7578,37.4273,74.0802,-1,-1}, // monster
	{V_MONSTER,2129.4233,-358.8318,68.1227,301.2070,-1,-1}, // monster
	{V_MONSTER,2218.0007,-1166.0787,26.0979,269.7605,-1,-1}, // monsterspawn
	{V_SANCHEZ,322.3486,871.5268,20.7706,126.7716,-1,-1}, // dirtbike
	{V_MONSTER,471.0568,957.5352,5.1397,271.8694,-1,-1}, // monster

	{V_QUAD,2155.2903,-95.7832,3.1043,35.5131,-1,-1}, // quadbike
	{V_SPEEDER,2101.1611,-98.1321,-0.5383,110.4218,-1,-1}, // boat
	{V_BMX,1938.2843,-1362.9536,17.4298,92.1041,-1,-1}, // bycycle
	{V_SANCHEZ,1961.0875,-1389.5693,17.2068,177.9442,-1,-1}, // pcj
	{V_SANCHEZ,1952.9114,-1383.5287,18.3597,192.1973,-1,-1}, // pcj
	{V_SANCHEZ,1970.8129,-1446.1788,13.2970,94.7133,-1,-1}, // dirtbike
	{V_BMX,1889.3635,-1448.5939,13.2699,89.4957,-1,-1}, // bycycle
	{V_RUSTLER,1860.7959,-2623.4519,13.3287,3.9905,-1,-1}, // planespit
	{V_RUSTLER,1718.2184,-2625.3433,13.3286,352.5374,-1,-1}, // plane
	{V_NEVADA,1482.4989,-2620.6145,13.3287,266.7185,-1,-1}, // nevada
	{V_RUSTLER,837.2863,-2045.1538,12.5468,2.2953,-1,-1}, // vplane
	{V_MONSTER,-81.9674,-1584.9633,2.2904,47.6283,-1,-1}, // vmonster

//SECRETBASE
//	{V_HYDRA,380.515594,2538.496337,16.539062,180.0,58,8},
//	{V_HYDRA,365.3151,2536.3821,16.3921,186.4521,58,8}, //secretbase hunter V_HUNTER

//WATER TRANSPORTS
	{V_REEFER,2293.4219,517.5514,1.7537,270.7889,1,3}, //	3  (  
	{V_TROPIC,-218.462371,-1728.921020,1.584892,0.0,1,3}, //  3  ()
	{V_PREDATOR,1624.5901,565.8568,1.7817,200.5292,1,3}, //
	{V_JETMAX,328.223144,-1911.753906,1.531687,0.0,1,3}, //
	{V_JETMAX,772.4293,2912.5579,1.0753,69.6706,1,3}, //
	{V_JETMAX,-94.6885,455.4018,1.5719,250.5473,1,3}, //
	{V_LAUNCH,733.004821,-1508.589965,1.673374,0.0,1,3}, //
	{V_MARQUIS,-429.330993,1163.593505,1.576516,0.0,1,3}, //

	{V_JETMAX,-928.969421,2682.082519,40.096523,260.5732,1,3}, //
	{V_MARQUIS,-816.3951,2222.7375,43.0045,268.1861,1,3}, //

	{V_JETMAX,-2240.853759,2434.016357,1.301584,0.0,1,3}, //
	{V_MARQUIS,-2204.891357,2427.672119,1.644712,0.0,1,3}, //

	{V_LAUNCH,-1413.357421,285.362091,1.539489,90.0,1,3}, //
	{V_JETMAX,-1649.985229,253.474777,1.591548,90.0,1,3}, //


	{V_JESTER,-1662.313842,443.360931,6.814215,270.6935,-1,-1}, //airport chopper
	{V_TAXI,2100.694,-1782.087,13.05289,100.0,-1,-1}, // taxi // 33
	{V_TAXI,333.9377,-1808.899,4.065025,100.0,-1,-1}, // taxi
	{V_CABBIE,2856.975,-1851.991,10.77971,100.0,-1,-1}, // cabbie
	{V_STRETCH,2133.127929,2355.674560,10.471888,90.0,-1,-1}, // limo
	{V_STRETCH,2215.352,1325.103,10.44999,100.0,-1,-1}, // limo
	{V_STRETCH,-376.536865,1154.309082,19.742187,0.0,-1,-1}, // limo

	{V_CROPDUST,1421.8922,-2491.6023,13.3860,271.9363,13,13}, // repcsi ls
	{V_SHAMAL,1476.8854,1791.0751,10.5660,173.6778,101,1}, // repcsi lv
	{V_NEVADA,-1646.9740,-153.3067,15.1213,317.3889,43,0}, // repcsi sf

	{V_MAVERICK,1614.7153,1548.7513,11.2749,347.1516,58,8},
	{V_MAVERICK,1647.7902,1538.9934,11.2433,51.8071,0,8},
	{V_STUNT,1583.678100,1195.370971,10.812500,0.0,1,1}, //

	{V_RAINDANC,-2227.513916,2326.450439,7.546875,0.0,-1,-1},
	{V_SPARROW,-1465.884643,1489.550048,8.269489,0.0,0,8},
	{V_SPARROW,1118.040039,-2052.400390,74.441894,0.0,-1,-1},

	{V_LEVIATHN, 2434.139892,2785.981445,10.487292,180.0,-1,-1},
	{V_CARGOBOB, 339.961669,2466.137207,16.511519, 0.0,-1,-1},
	{V_SEASPAR, -781.326232,2435.869140,157.214242,0.0,-1,-1},

	{V_MAVERICK,1290.273071,-786.786865,97.172073,0.0,-1,-1},

//----------------------------POLICE DEPARTMENTS-------------------------------
//1-st POLICE Department
	{V_COPCARRU, 1535.861816,-1668.105712,13.136651, 0.0,-1,-1},
	{V_COPBIKE, 1535.655639,-1677.509521,13.136195, 0.0,-1,-1},
	{V_COPCARSF, 1564.711425,-1710.237304,5.646468, 0.0,-1,-1},
	{V_FBIRANCH, 1538.605102,-1646.273437,5.645132, 180.0,-1,-1},
//	{V_COPCARSF, 1587.414062,-1710.529663,5.643315, 0.0,-1,-1},
	{V_FBITRUCK, 1528.584960,-1683.566406,6.017978, 90.0,-1,-1},
//	{V_SWATVAN, 1528.412353,-1688.472045,6.018056, 90.0,-1,-1},

//2-st POLICE Department
	{V_POLMAV,-1680.362182,705.798828,30.701562, 0.0,58,8}, //POLISE 2 OSTR
	{V_FBIRANCH,-1600.234375,676.249694,-5.585825, 0.0,-1,-1},
	{V_ENFORCER,-1639.449218,653.676330,-5.198269, -90.0,-1,-1},
//	{V_FBITRUCK, -1639.463378,686.343994,-5.672295, -90.0,-1,-1},
//	{V_COPCARVG, -1573.603759,705.714721,-5.675840, -90.0,-1,-1},
	{V_COPCARSF,-1622.233154,651.307128,6.843786,0.0,-1,-1},
	{V_COPBIKE,-1634.547363,651.403076,7.229953,0.0,-1,-1},
//	{V_COPCARSF,-1605.751098,674.413879,6.894676,0.0,-1,-1},

//3-st POLICE Department



//1.1st Dep
//1.2st Dep
//V_ENFORCER

	{V_COPCARVG,2277.6846,2477.1096,10.5652,180.1090,0,1},
	{V_COPCARVG,2256.2891,2458.5110,10.5680,358.7335,0,1},
	{V_COPBIKE,2294.7305,2441.2651,10.3860,9.3764,0,0},
	{V_COPBIKE,2290.7268,2441.3323,10.3944,16.4594,0,0},

//------------------------------------------------------------------------------

	{V_INFERNUS,-2119.7756,-2513.2112,31.1944,324.9478,43,0}, // falaut
	{V_SAVANNA,-275.5049,-2183.6621,28.5521,209.4473,6,1}, // mucsaut
	{V_NRG500,-2798.1997,-340.0352,6.9641,268.1042,6,1}, // 
	{V_SUPERGT,-2776.5549,-282.3964,6.8190,0.2948,6,1}, // 
	{V_SULTAN,-2670.1294,-35.5361,4.1160,179.7575,6,1}, // 
	{V_SUPERGT,-2695.8335,98.8262,4.1156,85.0947,6,1}, // 
	{V_TORNADO,-2758.6699,629.0272,27.6919,357.6837,6,1}, // 
	{V_SANCHEZ,-2619.6519,730.0139,28.4301,272.1183,6,1}, // 
	{V_CHEETAH,-2575.2166,915.5255,64.7610,270.3451,6,1}, // 
	{V_EUROS,-2354.6045,983.5653,50.4769,1.8649,6,1}, // 

//
	{V_ELEGY,-2111.5969,740.7242,69.3425,90.0,6,1}, // CHANGE POSITION
	{V_VORTEX,-2431.136474,2316.403564,4.664079,0.0,6,1}, // 

	{V_SULTAN,-2135.472167,-416.524902,34.993389,0.0,-1,1},
	{V_WASHING,-1771.6229,740.3652,32.5150,270.7529,6,1}, // 
	{V_QUAD,-1512.0016,747.3326,6.9656,29.9548,6,1}, // 
	{V_LANDSTAL,-1573.8352,1225.7545,6.9668,96.8992,6,1}, // 
	{V_TAMPA,-1995.1827,1331.6113,6.9650,134.6279,6,1}, // 
	{V_PCJ600,-2524.0088,1227.3540,37.2045,25.9840,6,1}, // 
	{V_STALLION,-2279.5342,1093.4169,79.8602,193.9903,6,1}, // 


	{V_STALLION,-2437.737548,2512.243896,13.628739 ,0.0,-1,-1}, // 
	{V_TAMPA,1665.782592,2780.436767,10.820312,90.0,-1,-1}, // 


	{V_TAMPA,-2242.4177,529.7567,34.9506,178.2403,6,1}, // 
	{V_SUPERGT,-2266.9907,148.8022,34.9401,87.7605,6,1}, // 
	{V_SAVANNA,-2089.7021,-83.5836,34.9495,184.7049,6,1}, // 
	{V_INFERNUS,-1534.9027,-418.9227,5.9090,43.2217,6,1}, // 
	{V_TURISMO,-1630.0532,-184.6835,14.1309,61.6525,6,1}, // 
	{V_LANDSTAL,-1897.8704,-774.0885,31.8018,266.9753,6,1}, // 
	{V_QUAD,-1898.8020,-960.8665,31.8016,266.5754,6,1}, //

//AERO 2
	{V_BEAGLE,-1341.1079,-254.3787,15.0701,321.6338,1,1}, //
	{V_SHAMAL,-1371.1775,-232.3967,15.0676,315.6091,1,1}, //

	{V_SHAMAL,1642.9850,-2425.2063,14.4744,159.8745,1,1}, //

//TRAMM
//	{V_STREAK,-1943.352661,156.236022,25.718618,0.0,121,1}, //
//	{V_TRAM,-2251.617675,140.783950,35.171875,0.0,12,12}, //
//	{V_FREIBOX,-1943.352661,156.236022,23.718618,0.0,99,81}, //

//TRUCKS AND TRAILERS
	{V_LINERUN, 2440.162109, -1135.776245, 34.527168, 0.0, -1,-1}, // vtruck
	{V_LINERUN, -2041.904052, -2388.856201, 30.257677, 90.0, -1,-1}, // vtruck
	{V_PETROTR, -2014.336669, -2409.701416, 30.282669, 180.0, -1,-1}, // vtruck trailer

	{V_RDTRAIN,-84.4578,-1190.5831,1.4297,74.6822,-1,-1}, // vtruck
	{V_PETRO,-76.5145,-1111.3696,0.7578,157.2079,-1,-1}, // vtruck

//	{V_ARTICT3,-55.013088,-1145.097656,0.415555,38.0,-1,-1}, // vtruck trailer
//	{V_ARTICT2,-97.274795,-379.809600,1.429687,0.0,-1,-1}, // vtruck trailer


//CARIERRE V_DUMPER
//	{V_DUMPER, 335.0704, 890.3558, 20.5333, 189.0, 58, 8}, //3 OSTR
	{V_DUMPER, 636.4107, 889.8556, -41.9449, 149.1991, -1, -1}, //3 OSTR
	{V_DUMPER, 528.7937, 847.6982, -43.3877, 0.0, -1, -1} //3 OSTR

};


// vehicle spawns from lvdm
new VehicleLVDMSpawns[][VehicleSpawnInfo] = {

	{V_TURISMO,2040.0520,1319.2799,10.3779,183.2439,16,16},
	{V_BANSHEE,2040.5247,1359.2783,10.3516,177.1306,13,13},
	{V_WASHING,2110.4102,1398.3672,10.7552,359.5964,13,13},
	{V_INFERNUS,2074.9624,1479.2120,10.3990,359.6861,64,64},
	{V_ZR350,2075.6038,1666.9750,10.4252,359.7507,94,94},
	{V_BULLET,2119.5845,1938.5969,10.2967,181.9064,22,22},
	{V_BULLET,1843.7881,1216.0122,10.4556,270.8793,60,1},
	{V_BUFFALO,1944.1003,1344.7717,8.9411,0.8168,30,30},
	{V_BUFFALO,-2231.238769,305.601837,34.774967,0.0,90,90},
	{V_CHEETAH,1685.4872,1751.9667,10.5990,0.0,25,1},
	{V_INFERNUS,2034.5016,1912.5874,11.9048,0.2909,123,1},

//Military Base
	{V_PATRIOT,270.508148,1966.757080,17.660625,251.3278,43,0}, //
	{V_PATRIOT,272.634033,1978.573120,17.660625,310.9081,43,0}, //
//	{V_PATRIOT,279.718658,2011.741699,17.660625,310.9714,43,0}, //

//Casino 4 dragons
	{V_ELEGY,2038.1044,1006.4022,10.4040,179.2641,11,1}, //
	{V_JESTER,2038.1614,1014.8566,10.4040,179.8665,11,1}, //

	{V_SULTAN,2142.064208,1019.268798,10.479934,90.0,11,1}, //
	{V_SULTAN,2558.870605,2059.468505,10.572426,0.0,11,1}, //

	{V_INFERNUS,2172.1682,1988.8643,10.5474,89.9151,116,1},
	{V_BANSHEE,2245.5759,2042.4166,10.5000,270.7350,14,14},
	{V_ZR350,2361.1538,1993.9761,10.4260,178.3929,101,1},
	{V_UTILITY,2221.9946,1998.7787,9.6815,92.6188,53,53},
	{V_URANUS,-2794.197509,237.408340,7.187500,0.0,116,1},
	{V_EUROS,2276.7085,1938.7263,31.5046,359.2321,40,1},
	{V_EUROS,2602.7769,1853.0667,10.5468,91.4813,43,1},
	{V_PHOENIX,2610.7600,1694.2588,10.6585,89.3303,69,1},
	{V_EUROS,2635.2419,1075.7726,10.5472,89.9571,53,1},
	{V_ELEGY,2577.2354,1038.8063,10.4777,181.7069,35,1},
	{V_ELEGY,1881.0510,957.2120,10.4789,270.4388,11,1},
	{V_SLAMVAN,2039.1257,1545.0879,10.3481,359.6690,123,1},
	{V_SLAMVAN,2009.8782,2411.7524,10.5828,178.9618,66,1},
	{V_BANSHEE,2010.0841,2489.5510,10.5003,268.7720,1,2},
	{V_CHEETAH,2076.4033,2468.7947,10.5923,359.9186,36,1},
	{V_MAVERICK,2093.2754,2414.9421,74.7556,89.0247,26,57},
	{V_SUPERGT,2352.9026,2577.9768,10.5201,0.4091,7,7},

//  ( 3-)
	{V_SUPERGT, 2166.6963,2741.0413,10.5245,89.7816,52,52},
	{V_FCR900, 2142.460693,2799.496582,10.390315,90.0,-1,-1},

//KOlhoz
	{V_MONSTER, -91.542282,-89.598037,3.117187,0.0,-1,-1},
	{V_NRG500, -66.665290,144.868133,3.117187,0.0,-1,-1},

//CLUBCARS
	{V_FCR900, 1825.442749,2869.035888,10.835937, 180.0, 112,1},
	{V_MONSTER, 1127.064941,2840.785644,11.354654, 180.0, 112,1},
	{V_SLAMVAN, 1132.820678,2701.468994,10.820312, 90.0, 112,1},

	{V_INFERNUS,1960.9989,2754.9072,10.5473,200.4316,112,1},
	{V_BANSHEE,-1507.234985,1966.654174,48.421875,0.0,2,1},
	{V_CHEETAH,1673.8038,2693.8044,10.5912,359.7903,40,1},
	{V_BUFFALO,-2847.672851,-878.060668,9.154472,0.0,30,30},
	{V_PHOENIX,1580.4537,2838.2886,10.6614,181.4573,75,77},
	{V_UTILITY,1555.2734,2750.5261,10.6388,91.7773,62,62},
	{V_SLAMVAN,1455.9305,2878.5288,10.5837,181.0987,118,1},
	{V_ZR350,1537.8425,2578.0525,10.5662,0.0650,121,1},
	{V_TURISMO,1433.1594,2607.3762,10.3781,88.0013,16,16},
	{V_PHOENIX,2223.5898,1288.1464,10.5104,182.0297,18,1},
	{V_URANUS,2451.6707,1207.1179,10.4510,179.8960,24,1},
	{V_UTILITY,2461.7253,1357.9705,10.6389,180.2927,62,62},
	{V_URANUS,2461.8162,1629.2268,10.4496,181.4625,117,1},
	{V_ZR350,2395.7554,1658.9591,10.5740,359.7374,0,1},
	{V_PEREN,1553.3696,1020.2884,10.5532,270.6825,119,50},
	{V_LANDSTAL,1380.8304,1159.1782,10.9128,355.7117,123,1},
	{V_MOONBEAM,1383.4630,1035.0420,10.9131,91.2515,117,227},
	{V_PEREN,1445.4526,974.2831,10.5534,1.6213,109,100},
	{V_LANDSTAL,-2621.397216,1375.465209,6.775386,0.0,113,1},
	{V_PEREN,1658.5463,1028.5432,10.5533,359.8419,101,101},
	{V_BF400,1064.2332,1215.4158,10.4157,177.2942,72,1},
	{V_BF400,1111.4536,1788.3893,10.4158,92.4627,72,1},
	{V_NRG500,953.2818,1806.1392,8.2188,235.0706,3,8},
	{V_NRG500,995.5328,1886.6055,10.5359,90.1048,3,8},
	{V_FCR900,993.7083,2267.4133,11.0315,1.5610,75,13},
	{V_SLAMVAN,1439.5662,1999.9822,10.5843,0.4194,66,1},
	{V_NRG500,-2732.746337,2374.928466,72.084022,0.0,6,25},
	{V_NRG500,2156.3540,2188.6572,10.2414,22.6504,6,25},

	{V_NRG500,2476.7900,2532.2222,21.4416,0.5081,8,82},
	{V_SLAMVAN,2580.5320,2267.9595,10.3917,271.2372,8,82},
	{V_NRG500,2814.4331,2364.6641,10.3907,89.6752,36,105},
	{V_SLAMVAN,-2226.167480,-226.242919,35.051227,0.0,97,1},
	{V_FCR900,1670.1089,1297.8322,10.3864,359.4936,87,118},

	{V_CHEETAH,-1978.408691,445.592926,27.117801,0.0,58,8},
	{V_RUSTLER,1283.0006,1324.8849,9.5332,275.0468,7,6}, //11.5332
	{V_RUSTLER,1283.5107,1361.3171,9.5382,271.1684,1,6}, //11.5382
	{V_CHEETAH,1319.1038,1279.1791,10.5931,0.9661,62,1},
	{V_FCR900,1710.5763,1805.9275,10.3911,176.5028,92,3},
	{V_FCR900,2805.1650,2027.0028,10.3920,357.5978,92,3},
	{V_SLAMVAN,2822.3628,2240.3594,10.5812,89.7540,123,1},
	{V_FCR900,2876.8013,2326.8418,10.3914,267.8946,115,118},
	{V_BANSHEE,2842.0554,2637.0105,10.5000,182.2949,1,3},
	{V_TAMPA,-2400.332031,-608.243652,132.648437,0.0,72,39},
	{V_TAMPA,-2510.048095,1224.527587,37.086101,0.0,75,39},

	{V_FCR900,2104.9446,2658.1331,10.3834,82.2700,36,0},
	{V_FCR900,1914.2322,2148.2590,10.3906,267.7297,36,0},
	{V_TAMPA,1904.7527,2157.4312,10.5175,183.7728,83,36},
	{V_FCR900,1534.3204,2202.8970,10.3644,4.9108,118,118},
	{V_TAMPA,1613.1553,2200.2664,10.5176,89.6204,89,35},
	{V_LANDSTAL,1552.1292,2341.7854,10.9126,274.0815,101,1},
	{V_PEREN,1637.6285,2329.8774,10.5538,89.6408,101,101},
	{V_LANDSTAL,1357.4165,2259.7158,10.9126,269.5567,62,1},
	{V_SLAMVAN,1281.7458,2571.6719,10.5472,270.6128,106,1},
	{V_NRG500,1305.5295,2528.3076,10.3955,88.7249,3,8},
	{V_FCR900,993.9020,2159.4194,10.3905,88.8805,74,74},
	{V_CHEETAH,1512.7134,787.6931,10.5921,359.5796,75,1},
	{V_NRG500,2299.5872,1469.7910,10.3815,258.4984,3,8},
	{V_NRG500,2133.6428,1012.8537,10.3789,87.1290,3,8},
	{V_CHEETAH,2266.7336,648.4756,11.0053,177.8517,0,1}, //
	{V_PCJ600,2404.6636,647.9255,10.7919,183.7688,53,1}, //
	{V_SUPERGT,2628.1047,746.8704,10.5246,352.7574,3,3}, //
	{V_TAMPA,2817.6445,928.3469,10.4470,359.5235,72,39}, //
	{V_SLAMVAN,1919.8829,947.1886,10.4715,359.4453,11,1}, //
	{V_ELEGY,1881.6346,1006.7653,10.4783,86.9967,11,1}, //

	{V_BOBCAT,9.1065,1165.5066,19.5855,2.1281,101,25}, //
	{V_FREEWAY,-504.896514,-98.296997,62.718135,0.0,11,11}, //
	{V_FREEWAY,-1002.657958,1249.384887,33.263801,0.0,22,22}, //
	{V_WAYFARER,69.4633,1217.0189,18.3304,158.9345,10,1}, //
	{V_WAYFARER,-199.4185,1223.0405,19.2624,176.7001,25,1}, //
	{V_RUSTLER,325.4121,2538.5999,17.5184,181.2964,71,77}, //
	{V_RUSTLER,291.0975,2540.0410,17.5276,182.7206,7,6}, //
	{V_TORNADO,384.2365,2602.1763,16.0926,192.4858,72,1}, //
	{V_WAYFARER,423.8012,2541.6870,15.9708,338.2426,10,1}, //
	{V_WAYFARER,-1091.575805,-1654.377929,76.373939,0.0,10,1}, //
	{V_SADLER,596.8064,866.2578,-43.2617,186.8359,67,8}, //
	{V_SADLER,835.0838,836.8370,11.8739,14.8920,8,90}, //
	{V_TAMPA,843.1893,838.8093,12.5177,18.2348,79,39}, //
	{V_LANDSTAL,-235.9767,1045.8623,19.8158,180.0806,75,1}, //
	{V_COPCARRU,-211.5940,998.9857,19.8437,265.4935,0,1}, //
	{V_BOBCAT,-304.0620,1024.1111,19.5714,94.1812,96,25}, //
	{V_HOTDOG,-290.2229,1317.0276,54.1871,81.7529,1,1}, //
	{V_TURISMO,-290.3145,1567.1534,75.0654,133.1694,61,61}, //

	{V_BANDITO,-441.3438,2215.7026,42.2489,191.7953,41,29}, //
	{V_BANDITO,-2686.578369,885.874084,79.359535,0.0,41,29}, //
	{V_SLAMVAN,-371.7973,2234.5527,42.3497,285.9481,41,29}, //
	{V_BANDITO,-1727.986328,-153.794509,3.212345,0.0,41,29}, //
	{V_SANCHEZ,-660.7385,2315.2642,138.3866,358.7643,6,6}, //

	{V_ESPERANT,-2261.783935,2288.625976,4.820213,0.0,13,76}, //
	{V_BANSHEE,114.7416,1048.3517,13.2890,174.9752,1,2}, //
	{V_INFERNUS,-290.0065,1759.4958,42.4154,89.7571,116,1}, //
	{V_NRG500,-302.5649,1777.7349,42.2514,238.5039,6,25}, //
	{V_FELTZER,-1039.526733,-1195.008789,129.222198,0.0,75,1}, //
	{V_SLAMVAN,-866.1774,1557.2700,23.8319,269.3263,31,1}, //
	{V_UTILITY,-799.3062,1518.1556,26.7488,88.5295,53,53}, //
	{V_FCR900,-749.9730,1589.8435,26.5311,125.6508,92,3}, //
	{V_YOSEMITE,-904.2978,1553.8269,25.9229,266.6985,34,30}, //
	{V_FCR900,-944.2642,1424.1603,29.6783,148.5582,92,3}, //
	{V_BANSHEE,-237.7157,2594.8804,62.3828,178.6802,1,2}, //

	{V_HOTKNIFE,2509.814941,2354.570800,10.403183,-90.0,3,3}, //
	{V_MONSTER,-1771.779907,1204.295166,24.829723,-90.0,-1,-1},
	{V_HUSTLER,-2346.410156,1114.532470,55.180374,183.0,-1,-1},

	{V_CHEETAH,-680.9882,955.4495,11.9032,84.2754,36,1}, //
	{V_SULTAN,-2552.542480,626.121276,27.470169,0.0,9,39}, //
	{V_SULTAN,2142.4023,1408.5675,10.5258,0.3660,17,1}, //
	{V_SULTAN,2196.3340,1856.8469,10.5257,179.8070,21,1}, //
	{V_SULTAN,2103.4146,2069.1514,10.5249,270.1451,33,0}, //
	{V_SULTAN,2361.8042,2210.9951,10.3848,178.7366,37,0}, //
	{V_SULTAN,-1993.2465,241.5329,34.8774,310.0117,41,29}, //
	{V_JESTER,-1989.3235,270.1447,34.8321,88.6822,58,8}, //
	{V_JESTER,-1946.2416,273.2482,35.1302,126.4200,60,1}, //
	{V_URANUS,-774.045715,-2137.752685,25.876852,0.0,24,1}, //
	{V_ELEGY,-1952.8894,258.8604,40.7082,51.7172,17,1}, //
	{V_INFERNUS,-1949.8689,266.5759,40.7776,216.4882,112,1}, //
	{V_BANSHEE,-444.062561,-2261.816650,46.999832,0.0,2,1}, //
	{V_JESTER,-1657.6660,1213.6195,6.9062,282.6953,13,8}, //
	{V_SULTAN,-1658.3722,1213.2236,13.3806,37.9052,52,39}, //
	{V_URANUS,-1660.8994,1210.7589,20.7875,317.6098,36,1}, //
	{V_UTILITY,-1645.2401,1303.9883,6.8482,133.6013,7,7}, //

	{V_INFERNUS,113.8611,1068.6182,13.3395,177.1330,116,1}, //
	{V_BANSHEE,159.5199,1185.1160,14.7324,85.5769,1,2}, //
	{V_INFERNUS,612.4678,1694.4126,6.7192,302.5539,75,1}, //
	{V_NRG500,661.7609,1720.9894,6.5641,19.1231,6,25}, //
	{V_NRG500,-2724.348632,985.318359,54.090805,0.0,8,82}, //
	{V_SAVANNA,711.4207,1947.5208,5.4056,179.3810,90,96}, //
	{V_SAVANNA,1031.8435,1920.3726,11.3369,89.4978,97,96}, //
	{V_SAVANNA,-1942.724121,1227.488525,31.243553,0.0,102,114}, //
	{V_SAVANNA,1641.6802,1299.2113,10.6869,271.4891,97,96}, //
	{V_SAVANNA,2135.8757,1408.4512,10.6867,180.4562,90,96}, //
	{V_SAVANNA,-2344.607666,-127.372894,34.945106,0.0,99,81}, //
	{V_SAVANNA,2461.7380,1345.5385,10.6975,0.9317,114,1}, //
	{V_SAVANNA,-2539.946533,2432.732910,18.702194,0.0,88,64}, //
	{V_SULTAN,2805.1685,1361.4004,10.4548,270.2340,17,1}, //
	{V_SUPERGT,2853.5378,1361.4677,10.5149,269.6648,7,7}, //
	{V_SAVANNA,2633.9832,2205.7061,10.6868,180.0076,93,64}, //
	{V_SAVANNA,2119.9751,2049.3127,10.5423,180.1963,93,64}, //
	{V_SAVANNA,-2111.433105,-2314.316650,30.258714,226.9852,93,64}, //
	{V_SAVANNA,2787.8975,-1876.2583,9.6966,0.5804,99,81}, //

	{V_INFERNUS,2771.2993,-1841.5620,9.4870,20.7678,116,1} //
};

new VehicleLevelSpawns[][VehicleSpawnInfo] = {

	{1,2507.1194,-1672.0026,13.3752,151.7406,-1,-1}, // lvl1car
	{1,2473.1926,-1692.8074,13.5147,185.3466,-1,-1}, // lvl1car
	{1,2443.1753,-1643.4983,13.4635,179.8084,-1,-1}, // lvl1car
	{2,2509.4746,-1686.5259,13.3920,45.2052,-1,-1}, //  lvl2car
	{3,2061.8252,-1694.3264,13.5469,268.3677,-1,-1}, // lvl2car
	{3,2095.4346,-1816.7876,13.3828,100.7804,-1,-1}, // lvl2car
	{4,2062.9409,-1783.5260,13.5526,170.9329,-1,-1}, // bycycle
	{4,1974.5032,-1577.1281,13.6000,236.0774,-1,-1}, // lvl2car
	{5,1936.1696,-1590.2274,13.5655,0.2501,-1,-1}, // lvl3car
	{5,1664.2101,-1608.9214,13.5469,99.7265,-1,-1}, // lvl3car
	{5,1544.7393,-1490.1561,13.5550,92.3693,-1,-1}, // lv3car
	{5,1530.8647,-1501.9451,13.5547,96.7727,-1,-1}, // lv3car
	{5,1585.7596,-1417.3674,13.5745,274.2409,-1,-1}, // lv3car
	{5,1566.4376,-1309.3285,17.1774,85.9056,-1,-1}, // lv3car
	{15,1798.8533,-1290.4866,13.4941,269.4398,-1,-1}, // lv15car
	{5,1619.1155,-1515.4388,13.5830,273.3464,-1,-1}, // lv3car
	{6,1968.7969,-1105.2159,25.4998,170.9778,-1,-1}, // lv4car
	{6,2045.7830,-1104.7937,24.4727,306.3415,-1,-1}, // lv4car
	{6,1978.2981,-1222.4176,20.0234,89.0798,-1,-1}, // lv4car
	{6,1852.4985,-1175.3591,23.8281,89.0952,-1,-1}, // lv4car
	{6,1856.6714,-1057.3165,23.9331,6.3496,-1,-1}, // lv4car
	{7,1763.1777,-1035.3685,23.9609,87.8300,-1,-1}, // lv5car
	{7,1695.6656,-1057.3094,23.9063,181.4175,-1,-1}, // lv5car
	{6,1661.5690,-1020.1589,23.8984,15.1686,-1,-1}, // lv4car
	{6,1551.9174,-1026.1078,23.9063,156.1736,-1,-1}, // lv4car
	{7,1332.9067,-1081.6321,25.1267,109.4965,-1,-1}, // lv5car
	{12,1396.2329,-954.4750,34.9181,265.1123,-1,-1}, // lv12car
	{6,1321.1194,-871.6872,39.5781,86.4294,-1,-1}, // lv6car
	{7,1329.8838,-836.3520,55.4324,261.6916,-1,-1}, // lv5car
	{7,1317.5902,-806.1083,78.2761,307.4813,-1,-1}, // lv5car
	{8,1252.2313,-807.8172,84.1406,338.8975,-1,-1}, // lv5car
	{7,1243.3571,-786.0731,90.2281,359.7236,-1,-1}, // lv5car
	{8,2818.1460,-1086.3120,31.1089,180.0379,-1,-1}, // lvl8car
	{5,1499.3032,-1286.6250,14.1323,84.4448,-1,-1}, // newvspawns
	{5,1362.6215,-1552.9481,13.2266,163.1715,-1,-1}, // vlvl5
	{7,1329.1322,-1434.5465,14.6345,178.1093,-1,-1}, // vlvl10
	{5,1167.5800,-1773.5697,13.2500,180.0618,-1,-1}, // vlv5
	{7,973.7094,-1832.7688,12.2906,77.1939,-1,-1}, // v7
	{7,931.7245,-1832.8137,12.2708,77.8647,-1,-1}, // vlvl7
	{7,816.4370,-1750.9691,13.2286,0.1984,-1,-1}, // vlv7
	{10,529.3150,-1722.2203,12.2327,83.2223,-1,-1}, // vlvl10
	{10,440.8567,-1749.0173,8.5379,174.0354,-1,-1}, // lvl10
	{10,473.0768,-1764.6591,5.2079,265.8541,-1,-1}, // vlv10
	{10,297.4179,-1716.7726,6.7378,72.8854,-1,-1}, // vlvl10
	{10,181.7001,-1535.5029,12.5564,332.5497,-1,-1}, // vlvl10
	{12,310.2231,-1688.3392,6.6519,257.4050,-1,-1}, // vlvl14
	{15,383.3008,-2074.1270,7.5156,181.0151,-1,-1}, // vlvl17
	{7,479.5381,-1497.6285,20.1238,177.7601,-1,-1}, // vlvl7
	{10,784.1212,-1623.2212,13.0664,90.8990,-1,-1}, // vlvl10
	{7,782.1212,-1605.4540,13.0625,82.0705,-1,-1}, // vlvl7
	{7,822.7065,-1493.8962,13.2571,271.1335,-1,-1}, // vlvl7
	{7,951.6801,-1355.8486,13.0234,263.0140,-1,-1}, // vlvl7
	{7,1121.6134,-1414.0759,13.2500,86.2094,-1,-1}, // vlvl7
	{8,1037.1713,-1125.4634,23.5787,0.6568,-1,-1}, // vlvl8
	{10,936.5328,-1121.8204,23.6882,184.5944,-1,-1}, // vlvl10
	{10,925.0693,-1121.4336,23.6964,178.5319,-1,-1}, // vlvl10
	{14,1006.1591,-932.9962,41.8594,274.9768,-1,-1}, // vlvl6
	{9,1054.6265,-881.6620,42.8737,11.2677,-1,-1}, // vlvl7
	{9,877.1146,-942.2459,41.2863,94.1803,-1,-1}, // vlvl7
	{8,831.8075,-858.0800,69.6046,17.5861,-1,-1}, // vlvl8
	{10,920.8649,-789.0234,114.0388,73.0905,-1,-1}, // vlvl10
	{8,838.0268,-756.6203,84.9675,41.8700,-1,-1}, // vlvl8
	{7,1060.0052,-1133.6038,23.6101,83.1905,-1,-1}, // lvvl7
	{5,1348.7952,-1439.1946,13.3288,172.8042,-1,-1}, // lvl5
	{5,1369.2942,-1889.2828,13.2979,183.5186,-1,-1}, // lvl5
	{7,1664.9742,-1891.6210,13.3287,181.3913,-1,-1}, // lvl7
	{5,1840.4922,-1863.5056,13.1679,265.1946,-1,-1}, // lvl5
	{5,1946.6034,-2108.5884,13.3300,84.1386,-1,-1}, // lvl5
	{5,1660.7640,-2448.4036,13.3365,264.7374,-1,-1}, // lvl5
	{17,1792.3103,-2408.3279,13.3365,352.9836,-1,-1}, // lvl20
	{5,2240.7935,-2133.2385,13.3286,311.9443,-1,-1}, // lvl5
	{5,2239.8882,-2018.3472,13.3287,64.6645,-1,-1}, // lvl5
	{5,2236.9026,-1739.3690,13.3293,271.7934,-1,-1}, // lvl5
	{7,2293.9290,-1744.4738,13.3287,270.3853,-1,-1}, // lvl5
	{7,2378.5596,-1890.8003,13.1678,93.1584,-1,-1}, // lvl5
	{5,2380.3411,-1926.8801,13.1647,0.7137,-1,-1}, // lvl5
	{5,2647.5940,-1850.2285,10.7891,207.1185,-1,-1}, // lvl5
	{11,-1592.081909,-2727.235107,48.539062,0.0,-1,-1}, // lvl11
	{5,2770.1711,-2031.3397,13.3420,94.5972,-1,-1}, // lvl5
	{15,2935.4053,-2051.1785,3.3296,90.9356,-1,-1}, // lvl15
	{5,2867.7668,-1747.9935,10.8271,358.2124,-1,-1}, // lvl5
	{9,2815.7358,-1540.8802,10.7036,3.1425,-1,-1}, // lvl5
	{9,2803.7961,-1542.1204,10.7062,182.6557,-1,-1}, // lvl5
	{5,2922.9241,-1258.0260,10.6473,9.0239,-1,-1}, // lvl5
	{9,2604.3477,-1144.9692,49.9987,93.6663,-1,-1}, // lvl9
	{6,2358.8176,-1372.5603,23.7998,167.2767,-1,-1}, // lvl6
	{5,2328.2671,-1525.1691,24.8938,5.5071,-1,-1}, // lvl5
	{8,2305.3328,-1536.7662,25.2533,177.5410,-1,-1}, // lvl8
	{8,1898.3131,-1267.0509,13.3388,268.4135,-1,-1}, // lvl8
	{5,2038.8135,-1221.1144,22.5157,129.4195,-1,-1}, // lvl5
	{8,2173.8013,-997.0818,62.7518,169.9280,-1,-1}, // lvl8
	{9,2457.8013,-959.5031,79.8665,359.3141,-1,-1}, // lvl9
	{8,1499.0817,-709.1434,95.1203,172.0317,-1,-1}, // lvl8
	{8,1285.9681,-618.7437,104.0724,43.4388,-1,-1}, // lvl8
	{7,913.8022,-666.8300,117.4427,235.6000,-1,-1}, // lvl7
	{9,192.8070,-1105.9463,64.3511,332.9678,-1,-1}, // lvl9
	{9,359.3071,-854.7225,11.4603,337.1469,-1,-1}, // lvl9
	{8,663.3029,-619.2434,16.7072,276.6303,-1,-1}, // lvl8
	{8,666.3506,-467.6815,16.7072,92.0845,-1,-1}, // lvl8
	{8,665.8613,-460.7023,16.7073,92.1626,-1,-1}, // lvl8
	{8,734.8677,-589.3069,17.0283,272.2606,-1,-1}, // lvl8
	{8,827.1958,-511.9892,17.1543,180.7998,-1,-1}, // lvl8
	{9,1029.7224,-308.0322,74.3626,180.7265,-1,-1}, // lvl9
	{9,1060.3031,-304.3328,74.3635,175.4635,-1,-1}, // lvl9
	{8,1096.4338,-346.7454,74.3636,5.0826,-1,-1}, // lvl8
	{9,251.7234,-268.0208,1.9519,85.9601,-1,-1}, // lvl9
	{9,314.9438,-195.6568,1.9494,0.7245,-1,-1}, // lvl9
	{9,314.8654,-31.3876,1.9490,98.7475,-1,-1}, // lvl9
	{9,219.1703,25.5450,2.9494,296.3790,-1,-1}, // lvl9
	{10,920.9443,75.0384,62.4291,41.5838,-1,-1}, // lvl10
	{10,753.3507,277.1113,27.7727,198.5655,-1,-1}, // lvl10
	{10,953.1068,191.2826,35.8748,251.9660,-1,-1}, // lvl10
	{10,621.3632,50.6374,1.4212,186.7549,-1,-1}, // lvl10
	{11,755.3005,383.4026,23.5433,281.1725,-1,-1}, // lvl11
	{11,750.5363,348.8127,20.7778,146.0320,-1,-1}, // lvl11
	{11,1021.5203,504.9634,20.6057,336.8246,-1,-1}, // lvl11
	{11,1231.2999,299.8349,19.9596,153.8852,-1,-1}, // lvl11
	{11,-1189.949096,-1138.230590,129.218750,0.0,-1,-1}, // lvl11
	{11,1289.2206,145.2008,20.8336,172.9028,-1,-1}, // lvl11
	{11,2500.217773,-1136.638549,39.156429, 0.0,-1,-1}, // lvl11
	{11,2356.907714,-1139.778076,27.911312, 0.0,-1,-1}, // lvl11
	{11,1980.360351,2626.241943,10.820312, 0.0,-1,-1}, // lvl11
	{11,1829.195678,2617.586914,10.820312, 180.0,-1,-1}, // lvl11
	{11,1373.2708,271.9889,19.9383,157.2122,-1,-1}, // lvl11
	{10,-1935.393798,585.370483,34.743949,0.0,-1,-1}, // lvl10
	{10,-1705.558105,389.280975,6.817683,0.0,-1,-1}, // lvl10
	{10,-1984.617431,952.293457,45.076190,0.0,-1,-1}, // lvl10
	{10,-2068.420410,-83.469001,34.793556,0.0,-1,-1}, // lvl10
	{8,-2334.171142,-1582.490966,483.596313,180.0,-1,-1}, //lvl8
	{15,-2641.499023,1375.769409,6.779906,0.0,-1,-1}, // lvl10
	{15,-2068.135986,13.385405,34.978034,0.0,-1,-1}, // lvl10
	{15,-2073.332031,-2552.942871,30.101694,0.0,-1,-1}, // lvl10
	{15,-2688.419433,268.922393,3.964961,0.0,-1,-1}, // lvl10
	{15,-1017.753723,-683.789123,32.007812,0.0,-1,-1}, // lvl10
	{14,-850.099914,2748.552978,45.839096,0.0,-1,-1}, // lvl10
	{14,2707.274414,-1271.183471,58.425025,0.0,-1,-1}, // lvl10
	{14,-23.182325,966.536193,19.587718,0.0,-1,-1}, // lvl10
	{14,13.848106,1514.734863,12.756023,0.0,-1,-1}, // lvl10
	{13,-615.982543,2711.865722,72.303291,0.0,-1,-1}, // lvl10
	{13,2080.641845,-633.754455,64.597694,0.0,-1,-1}, // lvl10
	{13,2036.568725,-2463.402099,13.203208,0.0,-1,-1}, // lvl10
	{12,-114.843551,867.604858,18.600900,0.0,-1,-1}, // lvl10
	{12,1582.407104,-2286.934814,-3.121465,0.0,-1,-1}, // lvl10
	{12,2182.169189,-2535.770019,13.203210,0.0,-1,-1}, // lvl10
	{12,-1349.191284,2047.086547,53.154140,0.0,-1,-1}, // lvl10
	{15,-2454.221191,157.129302,34.595684,0.0,-1,-1}, // lvl10
	{15,212.714492,1389.384521,10.585937,0.0,-1,-1}, // lvl10
	{15,-2614.440673,448.117462,14.265704,0.0,-1,-1}, // lvl10
	{15,-1508.924438,2660.501708,55.374965,0.0,-1,-1}, // lvl10
	{15,-1522.499023,2577.795654,55.829471,0.0,-1,-1}, // lvl10
	{14,2657.380615,-1417.831909,30.204063,0.0,-1,-1}, // lvl10
	{15,-1660.517456,2488.525878,87.048721,0.0,-1,-1}, // lvl10
	{15,2177.038574,-2305.245117,13.203190,0.0,-1,-1}, // lvl10
	{15,1941.316528,-2142.073486,13.213592,0.0,-1,-1}, // lvl10
	{2,-1705.427246,896.053833,24.546955,0.0,-1,-1}, // lvl10
	{4,-2400.385498,-2181.031982,32.946758,0.0,-1,-1}, // lvl10
	{3,-2175.871826,293.690155,34.774768,0.0,-1,-1}, // lvl10
	{5,-1410.947265,2656.199951,55.228286,0.0,-1,-1}, // lvl10
	{1,-2596.091796,308.824005,4.095557,0.0,-1,-1}, // lvl10
	{8,-1693.237915,977.420898,17.242288,0.0,-1,-1}, // lvl10
	{9,1724.999145,-2288.478271,13.195929,0.0,-1,-1}, // lvl10
	{11,1349.827148,-1286.469604,13.382812,0.0,-1,-1}, // lvl10
	{11,-1772.922485,1087.192871,45.101581,0.0,-1,-1}, // lvl10
	{2,-2264.416015,445.546600,34.829456,0.0,-1,-1}, // lvl10
	{11,-1203.266601,1830.315063,41.718750,0.0,-1,-1}, // lvl10
	{11,2504.978271,-1305.483398,34.647018,0.0,-1,-1}, // lvl10
	{1,-2312.654541,-33.085094,34.951175,0.0,-1,-1}, // lvl10
	{3,-1507.493041,2527.057373,55.227851,0.0,-1,-1}, // lvl10
	{5,-2524.761230,308.777923,34.773513,0.0,-1,-1}, // lvl10
	{7,-1434.199707,2175.520263,50.008739,0.0,-1,-1}, // lvl10
	{9,2301.668212,-2395.331298,13.041644,0.0,-1,-1}, // lvl10
	{2,-1031.385864,1540.800903,34.606834,0.0,-1,-1}, // lvl10
	{6,2421.833984,-1108.667236,40.977745,0.0,-1,-1}, // lvl10
	{8,-444.902374,621.349243,16.400814,0.0,-1,-1}, // lvl10
	{10,-1805.596679,2045.395385,8.953540,0.0,-1,-1}, // lvl10
	{1,-2050.782226,1108.381103,52.946708,0.0,-1,-1}, // lvl10
	{3,-540.450561,2583.795166,53.406147,0.0,-1,-1}, // lvl10
	{5,1937.205200,-541.376708,18.968635,0.0,-1,-1}, // lvl10
	{7,1653.864746,-2145.705322,13.211018,0.0,-1,-1}, // lvl10
	{9,-1453.996215,2652.256347,55.829002,0.0,-1,-1}, // lvl10
	{2,-2485.016845,61.441997,25.503559,0.0,-1,-1}, // lvl10
	{4,-2100.544921,-2238.150634,30.282487,0.0,-1,-1}, // lvl10
	{6,-1942.054931,2402.579833,49.076992,0.0,-1,-1}, // lvl10
	{8,-2248.361572,689.478149,49.025035,0.0,-1,-1}, // lvl10
	{10,-1672.420654,-987.226135,70.562141,0.0,-1,-1}, // lvl10
	{12,-2584.455078,586.952514,14.110915,0.0,-1,-1}, // lvl10
	{14,-2420.909667,740.805786,34.671958,0.0,-1,-1}, // lvl10
	{15,-1506.925048,2525.740966,55.680152,0.0,-1,-1}, // lvl10
	{11,1407.791137,-2347.792724,13.195434,0.0,-1,-1}, // lvl10
	{13,-1696.469360,977.090820,17.513023,0.0,-1,-1}, // lvl10
	{12,-1820.715820,-160.033416,9.035736,0.0,-1,-1}, // lvl10
	{14,-2291.356445,2658.460937,55.481483,0.0,-1,-1}, // lvl10
	{11,-1338.766601,2665.891845,50.124515,0.0,-1,-1}, // lvl10
	{13,-1799.264160,755.347229,24.817712,0.0,-1,-1}, // lvl10
	{12,2511.1599,49.4021,26.8557,267.5125,-1,-1}, // lvl12
	{11,-2447.150878,740.236083,34.644699,0.0,-1,-1}, // lvl11
	{5,-2067.252441,1413.302612,6.758692,0.0,-1,-1}, // lvl5
	{15,-1733.641723,190.339965,3.212133,0.0,-1,-1}, // lvl15
	{5,-2408.589843,536.614929,29.584415,0.0,-1,-1}, // lvl5
	{9,-1430.737426,-950.174316,201.027542,0.0,-1,-1}, // lvl5
	{9,-2134.776855,956.509155,79.578910,0.0,-1,-1}, // lvl5
	{11,-2045.156982,1108.153076,52.866855,180.0,-1,-1},
	{12,-2415.061767,977.221435,44.874309,180.0,-1,-1},
	{13,-2396.093261,895.818725,45.025302,180.0,-1,-1},
	{14,-2468.575927,741.232177,34.594589,180.0,-1,-1},
	{15,-2519.356201,307.189636,34.695575,180.0,-1,-1},
	{6,-2217.663085,-109.498687,34.899379,180.0,-1,-1},
	{7,-2272.041015,-121.251655,34.898410,180.0,-1,-1},
	{8,-2458.183593,-7.194068,27.516994,180.0,-1,-1},
	{9,-2448.614990,-84.787033,33.624122,180.0,-1,-1},
	{10,-2629.646240,-36.258346,3.915601,180.0,-1,-1},
	{11,-2615.953125,-189.960357,3.914054,180.0,-1,-1},
	{12,-2716.839355,-186.542694,3.913354,180.0,-1,-1},
	{13,-2802.058837,-153.487945,6.759522,180.0,-1,-1},
	{14,-2801.710937,5.573849,6.757425,180.0,-1,-1},
	{14,-2828.094238,441.923919,4.027803,180.0,-1,-1},
	{13,-2878.169189,747.213562,30.084104,180.0,-1,-1},
	{12,-2858.645507,874.369812,43.494087,180.0,-1,-1},
	{10,-2847.871093,946.159362,43.633762,180.0,-1,-1},
	{9,-2857.755126,1061.489746,31.655250,180.0,-1,-1},
	{8,-2839.553222,1303.459106,6.674636,180.0,-1,-1},
	{6,-2110.442382,1244.012207,18.550285,180.0,-1,-1},
	{15,-2178.527343,1223.783447,33.507392,180.0,-1,-1},
	{13,-2013.048217,769.479309,45.023719,180.0,-1,-1},
	{12,-2013.951293,705.753967,45.029327,180.0,-1,-1},
	{11,-1956.536132,585.402526,34.693920,180.0,-1,-1},
	{12,-2045.128051,466.213531,34.751323,180.0,-1,-1},
	{13,-1838.564331,-15.363636,14.698224,180.0,-1,-1},
	{14,-1855.139038,120.544425,14.697348,180.0,-1,-1},
	{15,-1231.025390,440.817199,6.767944,180.0,-1,-1},
	{6,-1238.910034,440.536407,6.764851,180.0,-1,-1},
	{7,-1247.551391,440.208953,6.772343,180.0,-1,-1},
	{8,-1476.543090,461.424530,6.765059,180.0,-1,-1},
	{9,-1828.593261,-49.043056,14.690624,180.0,-1,-1},
	{10,-1884.573242,-168.537567,11.536525,180.0,-1,-1},
	{11,-2055.563964,-308.032196,35.090892,180.0,-1,-1},
	{12,-2206.217529,-307.777801,35.144634,180.0,-1,-1},
	{13,-2144.625488,-410.612121,34.919441,180.0,-1,-1},
	{14,-2202.051757,-520.739746,47.099201,180.0,-1,-1},
	{14,-2110.149414,-962.723754,31.745277,180.0,-1,-1},
	{11,-1826.462646,-1338.166992,32.254547,180.0,-1,-1},
	{10,-1848.583618,-1616.915893,21.400211,180.0,-1,-1},
	{9,-1862.980834,-1614.904907,21.358432,180.0,-1,-1},
	{7,-1445.328857,-1495.895996,101.337478,180.0,-1,-1},
	{10,-1466.272460,-1556.307495,101.336975,180.0,-1,-1},
	{10,-970.249450,-1418.515136,129.637496,180.0,-1,-1},
	{10,-860.739074,-1448.223754,109.026710,180.0,-1,-1},
	{10,-835.560546,-1248.781982,72.889015,180.0,-1,-1},
	{10,-556.171813,-1044.773925,23.631345,180.0,-1,-1},
	{10,-369.012237,-1043.321899,58.943126,180.0,-1,-1},
	{10,-373.863250,-1444.758666,25.305643,180.0,-1,-1},
	{10,-80.645309,-1552.635864,2.189321,180.0,-1,-1},
	{10,294.027648,-1541.284545,24.170984,180.0,-1,-1},
	{10,304.800689,-1488.846679,24.180746,180.0,-1,-1},
	{10,437.138305,-1616.701904,25.563896,180.0,-1,-1},
	{10,547.344116,-1474.963989,14.310166,180.0,-1,-1},
	{10,478.356109,-1510.721801,20.121768,180.0,-1,-1},
	{10,683.737609,-1546.471191,14.426520,180.0,-1,-1},
	{10,703.317687,-1434.218261,13.120613,180.0,-1,-1},
	{10,743.631835,-1349.411743,13.082080,180.0,-1,-1},
	{10,750.841491,-1350.775146,13.082590,180.0,-1,-1},
	{10,670.988464,-1261.814941,13.208271,180.0,-1,-1},
	{10,775.033142,-1125.706909,23.405164,180.0,-1,-1},
	{10,766.116699,-1033.193969,23.614738,180.0,-1,-1},
	{10,781.679809,-1015.130004,25.941570,180.0,-1,-1},
	{10,926.710632,-996.988830,37.788822,180.0,-1,-1},
	{10,953.599670,-932.852172,42.313018,180.0,-1,-1},
	{10,1027.795043,-891.815185,41.740222,180.0,-1,-1},
	{10,1221.429443,-876.768066,42.473529,180.0,-1,-1},
	{10,1212.927124,-876.828857,42.493003,180.0,-1,-1},
	{10,1229.466064,-1005.935241,32.182121,180.0,-1,-1},
	{10,1220.293212,-1070.097534,28.803884,180.0,-1,-1},
	{10,1202.973388,-1100.392089,24.885143,180.0,-1,-1},
	{10,1183.895141,-1216.660644,18.319242,180.0,-1,-1},
	{10,1093.335449,-1216.161621,17.388019,180.0,-1,-1},
	{10,1087.965576,-1248.545898,15.404649,180.0,-1,-1},
	{10,1010.977539,-1301.774658,12.962424,180.0,-1,-1},
	{7,992.918579,-1254.508056,14.610272,180.0,-1,-1},
	{8,1014.413269,-1367.819824,12.949215,180.0,-1,-1},
	{8,1086.039916,-1381.870483,13.359054,180.0,-1,-1},
	{9,1147.433837,-1374.032836,13.355191,180.0,-1,-1},
	{9,1093.159179,-1315.289062,13.283145,180.0,-1,-1},
	{9,1107.176757,-1467.728149,15.376204,180.0,-1,-1},
	{10,1224.567749,-1534.403198,13.131401,180.0,-1,-1},
	{10,1273.709106,-1553.839721,13.138692,180.0,-1,-1},
	{10,1203.648925,-1628.177124,13.316934,180.0,-1,-1},
	{11,1184.052734,-1676.168579,13.126988,180.0,-1,-1},
	{11,1063.448852,-1739.908325,13.056447,180.0,-1,-1},
	{11,1081.711791,-1829.973876,13.203805,180.0,-1,-1},
	{12,1005.578613,-2233.725097,12.700041,180.0,-1,-1},
	{12,1398.113891,-2364.555664,13.132467,180.0,-1,-1},
	{12,1388.649536,-2314.168701,13.125119,180.0,-1,-1},
	{11,1385.353515,-2225.517822,13.124414,180.0,-1,-1},
	{12,1724.032592,-2092.572998,13.124336,180.0,-1,-1},
	{12,1704.261230,-2129.164062,13.133426,180.0,-1,-1},
	{12,1923.427978,-2119.758300,13.166819,180.0,-1,-1},
	{12,1975.233398,-2184.767822,13.126565,180.0,-1,-1},
	{11,2115.554931,-2144.043457,13.206958,180.0,-1,-1},
	{11,2090.651123,-2090.831298,13.118805,180.0,-1,-1},
	{11,2052.823486,-1905.237548,13.124258,180.0,-1,-1},
	{13,2248.644775,-1913.730712,13.126955,180.0,-1,-1},
	{13,2312.493896,-1993.241333,13.135048,180.0,-1,-1},
	{14,2473.395263,-1995.447509,13.126694,180.0,-1,-1},
	{11,2485.687744,-1953.026733,13.003611,180.0,-1,-1},
	{11,2684.880126,-2020.778686,13.110149,180.0,-1,-1},
	{15,2684.371093,-1989.574951,13.132552,180.0,-1,-1},
	{15,2639.946777,-2002.521362,13.133521,180.0,-1,-1},
	{15,2775.094482,-1932.982910,13.117679,180.0,-1,-1},
	{15,2862.818115,-1990.241821,10.513294,180.0,-1,-1},
	{11,2385.943847,-2159.845947,13.139413,180.0,-1,-1},
	{11,2340.735351,-2186.837402,13.125390,180.0,-1,-1},
	{11,2246.661132,-2157.667480,13.124783,180.0,-1,-1},
	{15,2729.363769,-1937.232299,13.124256,180.0,-1,-1},
	{15,2522.780761,-1898.065795,13.131592,180.0,-1,-1},
	{11,2455.118896,-1764.604858,13.159225,180.0,-1,-1},
	{11,2409.051757,-1721.201904,13.247531,180.0,-1,-1},
	{11,2370.479736,-1804.184082,13.134250,180.0,-1,-1},
	{11,2165.436767,-1690.054077,14.665166,180.0,-1,-1},
	{14,2187.606689,-1659.354492,14.660504,180.0,-1,-1},
	{14,2090.270263,-1568.542358,12.760601,180.0,-1,-1},
	{13,2120.618652,-1780.830810,12.962121,180.0,-1,-1},
	{13,2130.580322,-1489.684326,23.379762,180.0,-1,-1},
	{12,2217.533203,-1427.582763,23.393949,180.0,-1,-1},
	{12,2229.841308,-1348.387695,23.565059,180.0,-1,-1},
	{13,2276.082763,-1262.149902,23.559827,180.0,-1,-1},
	{13,2332.986083,-1237.600219,22.075338,180.0,-1,-1},
	{13,2365.635742,-1218.429321,27.173849,180.0,-1,-1},
	{14,2434.489501,-1243.278198,23.814294,180.0,-1,-1},
	{14,2428.002929,-1243.288574,23.753290,180.0,-1,-1},
	{14,2206.131347,-1153.733276,25.334329,180.0,-1,-1},
	{15,2147.852783,-1233.884033,23.754161,180.0,-1,-1},
	{15,2120.005371,-1134.849853,24.853433,180.0,-1,-1},
	{15,2060.900146,-1155.333862,23.453655,180.0,-1,-1},
	{12,2236.942871,86.534767,26.049343,90.0,-1,-1},
	{14,2261.006835,-85.023330,26.082094,90.0,-1,-1},
	{15,2357.353027,-81.527709,26.091787,-90.0,-1,-1},
	{12,2470.346435,-39.229301,26.060791,-90.0,-1,-1},
	{6,2444.390380,112.266609,26.050422,90.0,-1,-1},
	{15,2784.949951,67.212783,19.775897,-90.0,-1,-1},
	{14,2813.795166,-259.247009,9.968948,90.0,-1,-1},
	{14,2858.979736,-598.050292,10.736444,-90.0,-1,-1},
	{8,2542.827636,-967.216491,81.670036,90.0,-1,-1},
	{9,2365.089599,-651.510131,127.349990,90.0,-1,-1},
	{10,2251.613769,-370.349822,47.286125,-90.0,-1,-1},
	{11,2486.212402,-289.721557,16.677104,90.0,-1,-1},
	{11,2418.456054,336.990295,32.299751,90.0,-1,-1},
	{10,2443.252685,334.779693,32.098411,-90.0,-1,-1},
	{12,1751.646972,430.936950,18.413223,90.0,-1,-1},
	{12,1630.607055,266.472534,19.195158,-90.0,-1,-1},
	{13,1855.552856,735.765930,10.646953,90.0,-1,-1},
	{15,1946.487060,729.986267,10.399644,-90.0,-1,-1},
	{13,2161.575439,778.319396,10.817639,90.0,-1,-1},
	{10,2200.993896,938.270874,10.401405,90.0,-1,-1},
	{11,-204.407211,2736.582031,62.280033,90.0,-1,-1},
	{15,2162.853515,1022.237121,10.394897,-90.0,-1,-1},
	{7,2390.257324,986.111694,10.404885,90.0,-1,-1},
	{8,2461.014648,918.929138,10.398966,-90.0,-1,-1},
	{9,2460.541748,928.215209,10.405202,-90.0,-1,-1},
	{12,2552.532958,1030.834716,10.404829,-90.0,-1,-1},
	{13,2513.765869,1125.029296,10.395085,-90.0,-1,-1},
	{14,2568.290527,1148.394653,10.400631,90.0,-1,-1},
	{2,2635.441650,1181.947998,10.399897,-90.0,-1,-1},
	{3,2510.143554,1206.751098,10.399824,90.0,-1,-1},
	{4,2500.591064,1211.734863,10.396336,-90.0,-1,-1},
	{5,2539.624511,1266.085449,10.404196,90.0,-1,-1},
	{7,2587.491210,1323.971435,10.403752,-90.0,-1,-1},
	{8,2766.139404,1281.726196,10.327924,90.0,-1,-1},
	{10,2764.036132,1268.799682,10.322224,-90.0,-1,-1},
	{10,2817.437988,1269.768676,10.325962,90.0,-1,-1},
	{10,2771.076660,1432.093872,10.049060,90.0,-1,-1},
	{10,2851.511718,1640.177246,10.401064,-90.0,-1,-1},
	{10,2852.668457,1659.488403,10.404691,-90.0,-1,-1},
	{10,2831.657958,2017.242919,10.402733,90.0,-1,-1},
	{10,2786.272705,2197.176757,10.399016,90.0,-1,-1},
	{10,2812.677978,2152.171875,10.397680,90.0,-1,-1},
	{10,2852.749755,2330.644531,10.396202,-90.0,-1,-1},
	{10,2841.514160,2364.178222,10.395376,-90.0,-1,-1},
	{10,2815.811279,2375.429443,10.398076,-90.0,-1,-1},
	{10,2512.255615,2398.089843,10.402239,-90.0,-1,-1},
	{10,2524.409423,2373.352539,3.783255,90.0,-1,-1},
	{7,2511.966308,2492.692382,10.401024,-90.0,-1,-1},
	{7,2509.688964,2533.406250,10.397449,-90.0,-1,-1},
	{6,2529.684326,2530.286865,21.454208,90.0,-1,-1},
	{5,2373.160400,2527.801269,10.401923,-90.0,-1,-1},
	{5,2164.715332,2490.427734,10.398900,-90.0,-1,-1},
	{8,2103.095214,2079.207275,10.403109,90.0,-1,-1},
	{10,-303.861816,2683.999755,62.228450,90.0,-1,-1},
	{10,1925.843017,1988.928955,7.172915,-90.0,-1,-1},
	{10,1913.304321,2021.858032,13.369249,-90.0,-1,-1},
	{10,1860.632934,2030.256835,13.361943,90.0,-1,-1},
	{10,1876.490478,1776.703979,12.327685,-90.0,-1,-1},
	{10,1952.111938,1734.489990,12.327380,90.0,-1,-1},
	{10,2172.140625,1669.028808,10.397164,-90.0,-1,-1},
	{14,2186.974853,1871.221313,10.399317,-90.0,-1,-1},
	{15,2386.932861,2004.638183,10.399446,-90.0,-1,-1},
	{14,2283.601318,2049.751220,10.399586,-90.0,-1,-1},

	{15, 1179.078002,-1338.990356,13.861732, 90.0,-1,-1},
	{15, 1252.732055,-1154.119506,23.656250, -90.0,-1,-1},
	{15, 1452.443847,-1155.537475,23.833950, 90.0,-1,-1},
	{15, 1620.374145,-1165.885498,24.078125, -90.0,-1,-1},
	{15, 1739.998046,-1156.236083,23.828125, -90.0,-1,-1},
	{15, 1681.197265,-1462.047241,13.546875, 90.0,-1,-1},
	{15, 1745.994140,-1454.572265,13.546875, -90.0,-1,-1},
	{15, 1822.643554,-1402.709838,13.429687, 90.0,-1,-1},
	{14, 1534.074584,-1846.399902,13.546875, 0.0,-1,-1},
	{14, 1479.535522,-1844.706787,13.546875, 0.0,-1,-1},
	{14, 1630.676269,-1905.352661,13.551810, 0.0,-1,-1},
	{14, 1775.956787,-1933.347045,13.386354, 0.0,-1,-1},
	{14, 1809.991577,-2023.155273,13.542015, 0.0,-1,-1},
	{14, 1265.478271,-1361.004638,13.481269, 0.0,-1,-1},
	{12,2172.737792,1997.229980,10.399847,-90.0,-1,-1}

};
//------------------------------------------------------------------------------
new ActiveVehicles[MAX_VEHICLE_SPAWNS];

GetRndVModelByLevel(level)
{
	new leveledvehicles[VEHICLES_SIZE+1];
	new idx;
	for (new vlookupid=0;vlookupid<VEHICLES_SIZE;vlookupid++)
	{
		if (Vehicles[vlookupid][vehicle_level] == 0) continue;
	    if (Vehicles[vlookupid][vehicle_level] <= level)
	    {
	    	leveledvehicles[idx] = Vehicles[vlookupid][vehicle_model];
	    	idx++;
	    }
	}
	new rnd = random(idx);
	new vmodel;
	vmodel = leveledvehicles[rnd];
	return vmodel;
}

LoadVehicles()
{
	for(new i;i<sizeof(VehicleModelSpawns);i++)
	{
		if(VehicleModelSpawns[i][vspawn_model] != 0)
		{
			AddStaticVehicleEx(VehicleModelSpawns[i][vspawn_model],VehicleModelSpawns[i][vspawn_x],VehicleModelSpawns[i][vspawn_y],VehicleModelSpawns[i][vspawn_z],VehicleModelSpawns[i][vspawn_heading],VehicleModelSpawns[i][vspawn_colour1],VehicleModelSpawns[i][vspawn_colour2],never);
		}
	}
	for(new i;i<sizeof(VehicleLVDMSpawns);i++)
	{
		if(VehicleLVDMSpawns[i][vspawn_model] != 0)
		{
			AddStaticVehicleEx(VehicleLVDMSpawns[i][vspawn_model],VehicleLVDMSpawns[i][vspawn_x],VehicleLVDMSpawns[i][vspawn_y],VehicleLVDMSpawns[i][vspawn_z],VehicleLVDMSpawns[i][vspawn_heading],VehicleLVDMSpawns[i][vspawn_colour1],VehicleLVDMSpawns[i][vspawn_colour2],never);
		}
	}
	for (new i=1;i<sizeof(VehicleLevelSpawns);i++)
	{
		if((VehicleLevelSpawns[i][vspawn_model] >= 0) && (VehicleLevelSpawns[i][vspawn_model] <= 20))
		{
			new vspawnlevel=VehicleLevelSpawns[i][vspawn_model];
		    new vehiclemodel = GetRndVModelByLevel(vspawnlevel);
		    if((vehiclemodel >= VEHICLES_START) && (vehiclemodel <= (VEHICLES_START+VEHICLES_SIZE)))
		    {
				AddStaticVehicleEx(vehiclemodel,VehicleLevelSpawns[i][vspawn_x],VehicleLevelSpawns[i][vspawn_y],VehicleLevelSpawns[i][vspawn_z],VehicleLevelSpawns[i][vspawn_heading],VehicleLevelSpawns[i][vspawn_colour1],VehicleLevelSpawns[i][vspawn_colour2],never);
			}
		}
	}
}

GetSpawnVehicleModel(vehicleid)
{
	return ActiveVehicles[vehicleid];
}

GetVehicleName(vehiclemodel)
{
	new VehicleName[MAX_STRING];
	for(new vlookupid=0;vlookupid<VEHICLES_SIZE;vlookupid++)
	{
	    new lookupmodel = Vehicles[vlookupid][vehicle_model];
	    if (lookupmodel == vehiclemodel)
	    {
	        set(VehicleName,Vehicles[vlookupid][vehicle_name]);
	        return VehicleName;
	    }
	}
	return VehicleName;
}

stock GetVehicleSpeed(playerid)
{
    new Float:Vx,Float:Vy,Float:Vz,Float:rtn;
    if(IsPlayerInAnyVehicle(playerid)) GetVehicleVelocity(GetPlayerVehicleID(playerid),Vx,Vy,Vz);
	else return 1;
    rtn = floatsqroot(floatabs(floatpower(Vx + Vy + Vz,2)));
    return floatround(rtn * 100 * 1.61);
}

public CarsCommandHandler(playerid, cmdtext[])
{
	if(!strcmp(cmdtext, "/carlock", true)) 
	{
		if(!IsPlayerInAnyVehicle(playerid)) return SendClientMessage(playerid,COLOUR_RED, lang_texts[5][24]);
		new newstate,pv = GetPlayerVehicleID(playerid);
		if(VehicleDoors[pv] == 1) newstate = 0;
		else newstate = 1;
		VehicleDoors[pv] = newstate;
		for(new i;i<MAX_PLAYERS;i++)
		{
			if(IsPlayerConnected(i) && i != playerid) SetVehicleParamsForPlayer(pv, i, 0, newstate);
		}
		if(newstate == 1)
		{
			SendClientMessage(playerid,COLOUR_RED, lang_texts[5][25]);
			GameTextForPlayer(playerid,"~r~Locked",999,1);
		}
		else
		{
			SendClientMessage(playerid,COLOUR_RED, lang_texts[5][26]);
			GameTextForPlayer(playerid,"~g~Unlocked",999,1);
		}
		return 1;
	}
	if(!strcmp(cmdtext, "/carunlock", true))
	{
		if(!IsPlayerInAnyVehicle(playerid)) return SendClientMessage(playerid,COLOUR_RED, lang_texts[5][24]);
		new pv = GetPlayerVehicleID(playerid);
		if(VehicleDoors[pv] == 1) return 1;
		for(new i;i<MAX_PLAYERS;i++)
		{
			if(IsPlayerConnected(i) && i != playerid) SetVehicleParamsForPlayer(pv, i, 0, 0);
		}
		SendClientMessage(playerid,COLOUR_RED, lang_texts[5][26]);
		GameTextForPlayer(playerid,"~g~Unlocked",999,1);
		return 1;
	}
	return 0;
}
