//
// Created: 05.09.06
// Aurthor: Iain Gilbert
//


#if defined _weapons_included
#endinput
#endif

#define _weapons_included
#pragma library weapons
#include "base"

forward AmmunationInit();
forward IsPlayerAtAmmunation(playerid);
forward OnPlayerEnterAmmoCheckpoint(playerid);
forward IsPlayerAllowedWeapon(playerid,weaponid);
forward BuyWeapon(playerid,weaponid,bullets);
forward AmmunationCommandHandler(playerid,text[]);
forward WeaponMenuInit();
forward WeaponsMenu(playerid,row);
forward WeaponMenuExit(playerid);
forward WeaponPickup(playerid,pickupid);

#define MAX_BULLETS 2999
#define WeaponsSize 47
#define MAX_WEAPONS 46
#define AmmunationsCount 3

#define pistol_bullets 14
#define assault_bullets 30
#define shotgun_bullets 10
#define smg_bullets 100

new PlayerMenu[MAX_PLAYERS];
new Menu:WeaponMenu,Menu:PistolMenu,Menu:MicroSMGMenu,Menu:ShotgunsMenu,Menu:AssaultMenu,WeapPickup[4];
new WeaponDB[MAX_STRING] = "GTO/Weapon/";
new Ammunations[AmmunationsCount][CoordInfo] = 
{
	{291.0004,-84.5168,1001.5156}, // LVammunation1
	{293.2710,-108.9645,1001.5156}, // LSAmmunation1
	{290.3177,-38.7184,1001.5156} // LSAmmunation2
};

enum WeaponInfo 
{
	Weapon_ID, // id number of weapon
	Weapon_Name[MAX_NAME], // weapon name
	Weapon_Allowed, // is weapon allowed
	Weapon_MaxBullets, // max bullets
	Weapon_Cost, // cost per bullet
	Weapon_Level // player level required to buy this weapon
}

new Weapons[WeaponsSize][WeaponInfo] = {

	//id, "Name" ,Allowed,bullets, cost , level
	{0, "" , 0 , 1 , 0 , 0},
	{1, "" , 1 , 1 , 6000 , 3},
	{2, "  " , 1 , 1 , 6000 , 2},
	{3, "Night Stick" , 0 , 1 , 10000 , 18},
	{4, "" , 1 , 1 , 10000 , 4},
	{5, " " , 1 , 1 , 15000 , 7},
	{6, "Shovel" , 0 , 1 , 1000 , 0},
	{7, "" , 1 , 1 , 1000 , 11},
	{8, " " , 1 , 1 , 20000 , 8},
	{9, "" , 1 , 1 , 7500 , 6},
	{10, " Dildo" , 0 , 1 , 5000 , 9},
	{11, "" , 1 , 1 , 5000 , 5},
	{12, "  Dildo" , 0 , 1 , 7000 , 15},
	{13, " 2" , 1 , 1 , 5000 , 11},
	{14, " " , 1 , 1 , 1000 , 12},
	{15, "" , 1 , 1 , 1000 , 8},
	{16, "" , 1 , 1 , 67500 , 43},
	{17, " " , 1 , 1 , 20000 , 5},
	{18, " " , 1 , 1 , 30000 , 35},

	{19, "" , 0 , 1 , 1000 , 25},
	{20, "" , 0 , 1 , 1000 , 25},
	{21, "" , 0 , 1 , 1000 , 25},

	{22, "" , 1 , 999 , 125 , 0},
	{23, "  " , 1 , 999 , 125 , 10},
	{24, " " , 1 , 999 , 1200 , 12},
	{25, "" , 1 , 999 , 1100 , 5},
	{26, " " , 1 , 999 , 2300 , 25},
	{27, " " , 1 , 999 , 3750 , 26},
	{28, "  ()" , 1 , 999 , 2100 , 30},
	{29, "5(5) ()" , 1 , 999 , 2200 , 32},
	{30, "47 ( )" , 1 , 999 , 1500 , 35},
	{31, "M4 ()" , 1 , 999 , 4300 , 36},
	{32, "Tec9 ()" , 1 , 999 , 4150 , 29},
	{33, "" , 1 , 999 , 11500 , 20},
	{34, " " , 1 , 1 , 41000 , 38},
	{35, " " , 1 , 1 , 99000 , 60},
	{36, "  " , 1 , 1 , 99000 , 52},
	{37, "" , 1 , 1 , 1000 , 28},
	{38, "  ()" , 1 , 1 , 5000 , 60},

	{39, " " , 0 , 1 , 50000 , 62},
	{40, "  " , 0 , 1 , 100 , 62},

	{41, "  " , 1 , 1 , 4000 , 5},
	{42, "" , 1 , 1 , 1000 , 5},
	{43, "" , 1 , 1 , 6000 , 24},
	{44, "  ", 0 , 1 , 1000 , 0},
	{45, " " , 0 , 1 , 1000 , 0},
	{46, "" , 1 , 1 , 7000 , 1}
};

WeaponLoadAll()
{
	if(ForceOverwrite) return;
	new temp[MAX_STRING];
	if(!dini_Exists(ConfigDB)) dini_Create(ConfigDB);
	set(temp,dini_Get(ConfigDB,"Weapon_DB"));
	if(strlen(temp) > 0) set(WeaponDB,temp);
	if(!dini_Exists(WeaponDB))
	{
		WeaponSaveAll();
		return;
	}
	for(new i=0;i<WeaponsSize;i++)
	{
		new weapondbname[MAX_STRING];
		format(weapondbname,sizeof(weapondbname),"%sGTO.Weapon.%s.txt",WeaponDB,Weapons[i][Weapon_Name]);
		set(temp,dini_Get(weapondbname,"Name"));
		if (strlen(temp) > 0) set(Weapons[i][Weapon_Name],temp);
		set(temp,nullstr);
		set(temp,dini_Get(weapondbname,"IsAllowed"));
		if (strlen(temp) > 0) Weapons[i][Weapon_Allowed] = strval(temp);
		set(temp,nullstr);
		set(temp,dini_Get(weapondbname,"Level"));
		if (strlen(temp) > 0) Weapons[i][Weapon_Level] = strval(temp);
		set(temp,nullstr);
		set(temp,dini_Get(weapondbname,"Price"));
		if (strlen(temp) > 0) Weapons[i][Weapon_Cost] = strval(temp);
		set(temp,nullstr);
	}
	return;
}

WeaponSaveAll()
{
	new temp[MAX_STRING];
	if(dini_Exists(ConfigDB))
	{
		dini_Set(ConfigDB,"Weapon_DB",WeaponDB);
	}
	for(new i=0;i<WeaponsSize;i++)
	{
		new weapondbname[MAX_STRING];
		format(weapondbname,sizeof(weapondbname),"%sGTO.Weapon.%s.txt",WeaponDB,Weapons[i][Weapon_Name]);
		if (!dini_Exists(weapondbname)) dini_Create(weapondbname);
		dini_Set(weapondbname,"Name",Weapons[i][Weapon_Name]);
		valstr(temp,Weapons[i][Weapon_Allowed]);
		dini_Set(weapondbname,"IsAllowed",temp);
		set(temp,nullstr);
		valstr(temp,Weapons[i][Weapon_Level]);
		dini_Set(weapondbname,"Level",temp);
		set(temp,nullstr);
		valstr(temp,Weapons[i][Weapon_Cost]);
		dini_Set(weapondbname,"Price",temp);
		set(temp,nullstr);
	}
	return;
}

public AmmunationInit()
{
	for(new id=0;id<AmmunationsCount;id++)
	{
		//AddActiveCheckpoint(Ammunations[id][Coord_X],Ammunations[id][Coord_Y],Ammunations[id][Coord_Z],20,2);
		WeapPickup[id] = CreatePickup(1247,1,Ammunations[id][Coord_X],Ammunations[id][Coord_Y],Ammunations[id][Coord_Z]);
	}
	WriteLog("Ammunition checkpoints initialised");
}

public WeaponPickup(playerid,pickupid)
{
	for(new id=0;id<AmmunationsCount;id++)
	{
		if(WeapPickup[id] == pickupid && PlayerMenu[playerid] != 1)
		{
			PlayerMenu[playerid] = 1;
			TogglePlayerControllable(playerid,false);
			ShowMenuForPlayer(WeaponMenu,playerid);
		}
	}
	return 1;
}

public IsPlayerAtAmmunation(playerid)
{
	for(new id=0;id<AmmunationsCount;id++)
	{
		if(IsPlayerInRangeOfPoint(playerid,10,Ammunations[id][Coord_X],Ammunations[id][Coord_Y],Ammunations[id][Coord_Z])) return 1;
	}
	return 0;
}

public OnPlayerEnterAmmoCheckpoint(playerid)
{
	if(playerid == INVALID_PLAYER_ID) return;
	if(!IsPlayerConnected(playerid)) return;
	if(!IsPlayerAtAmmunation(playerid)) return;
	SendPlayerFormattedText(playerid,lang_texts[16][1],0,COLOUR_GREEN);
	SendPlayerFormattedText(playerid,lang_texts[16][2],0,COLOUR_GREEN);
	SendPlayerFormattedText(playerid,lang_texts[16][3],0,COLOUR_GREEN);
	SendPlayerFormattedText(playerid,lang_texts[16][4],0,COLOUR_GREEN);
}

oGetWeaponName(weaponid)
{
	new name[MAX_NAME];
	new lookupid=GetWeaponLookupID(weaponid);
	if(lookupid == -1) return name;
	set(name,Weapons[lookupid][Weapon_Name]);
	return name;
}

GetWeaponMaxAmmo(weaponid)
{
	new ammo;
	new lookupid=GetWeaponLookupID(weaponid);
	if(lookupid == -1) return ammo;
	ammo = Weapons[lookupid][Weapon_MaxBullets];
	return ammo;
}

public IsPlayerAllowedWeapon(playerid,weaponid)
{
	new lookupid=GetWeaponLookupID(weaponid);
	if(lookupid == -1) return 0;
	if(Weapons[lookupid][Weapon_Allowed] == 0) return 0;
	if(Weapons[lookupid][Weapon_Level] > GetPlayerLevel(playerid)) return 0;
	return 1;
}

IsWeaponHandToHand(weaponid)
{
	new weaponlookupid = GetWeaponLookupID(weaponid);
	if(weaponlookupid == -1) return 0;
	if(Weapons[weaponlookupid][Weapon_MaxBullets] == 1) return 1;
	return 0;
}

GetWeaponCost(weaponid)
{
	new weaponlookupid = GetWeaponLookupID(weaponid);
	if(weaponlookupid == -1) return 0;
	return Weapons[weaponlookupid][Weapon_Cost];
}

GetWeaponLookupID(weaponid)
{
	new lookupid = -1;
	for(new i=0;i<WeaponsSize;i++)
	{
		if(weaponid == Weapons[i][Weapon_ID]) lookupid = i;
	}
	return lookupid;
}

IsWeapon(weaponid)
{
	if((weaponid >= 0) && (weaponid <= 46)) return 1;
	return 0;
}

IsStoreWeapon(weaponid)
{
	if((weaponid >= 22 && weaponid <=34) || (weaponid >= 16 && weaponid <=18) || (weaponid >= 41 && weaponid <=43) || weaponid == 37 || weaponid == 39) return 1;
	return 0;
	/*
22 Pistol, 
23 Silenced Pistol, 
24 Desert Eagle, 
25 Shotgun, 
26 Sawn Off Shotgun, 
27 Combat Shotgun, 
28 Micro Uzi (Mac 10), 
29 MP5, 
30 AK47, 
31 M4, 
32 Tec9,
16-18, 33,34, 37, 39, 41-43, 46
*/
}

SendPlayerVendorWeapons(playerid)
{
	new string[MAX_STRING];
	SendPlayerFormattedText(playerid,  lang_texts[16][5]  , 0,COLOUR_GREEN);
	for (new weaponid=1;weaponid<MAX_WEAPONS;weaponid++)
	{
		if (IsPlayerAllowedWeapon(playerid,weaponid))
		{
			format(string,sizeof(string), lang_texts[16][6] ,oGetWeaponName(weaponid),GetWeaponCost(weaponid),weaponid);
			SendPlayerScrollingText(playerid, string);
		}
	}
}

public BuyWeapon(playerid,weaponid,bullets)
{
	new string[MAX_STRING];
	if((weaponid < 1) || (weaponid > 46))
	{
		SendPlayerFormattedText(playerid,lang_texts[16][7],0,COLOUR_RED);
		return 0;
	}
	if((bullets < 1) || (bullets > MAX_BULLETS))
	{
		SendPlayerFormattedText(playerid,lang_texts[16][8],0,COLOUR_RED);
		return 0;
	}
	if(!IsPlayerAtAmmunation(playerid))
	{
		SendPlayerFormattedText(playerid,lang_texts[16][9],0,COLOUR_RED);
		return 0;
	}
	if(!IsPlayerAllowedWeapon(playerid,weaponid))
	{
		format(string,sizeof(string),lang_texts[16][10],oGetWeaponName(weaponid));
		SendPlayerFormattedText(playerid,string,0,COLOUR_RED);
		return 0;
	}
	new purchasecost = GetWeaponCost(weaponid) * bullets;
	if(purchasecost < 1)
	{
		format(string,sizeof(string),lang_texts[16][11],oGetWeaponName(weaponid));
		SendPlayerFormattedText(playerid,string,0,COLOUR_RED);
		return 0;
	}
	if(oGetPlayerMoney(playerid) < purchasecost)
	{
		format(string,sizeof(string),lang_texts[16][12],purchasecost);
		SendPlayerFormattedText(playerid,string,0,COLOUR_RED);
		return 0;
	}
	oGivePlayerMoney(playerid,0-purchasecost,1);
	oGivePlayerWeapon(playerid,weaponid,bullets);
	if(bullets > 1) format(string,sizeof(string),lang_texts[16][13],bullets,oGetWeaponName(weaponid),purchasecost);
	else format(string,sizeof(string),lang_texts[16][14],oGetWeaponName(weaponid),purchasecost);
	SendPlayerFormattedText(playerid,string,0,COLOUR_GREEN);
	SendPlayerFormattedText(playerid,lang_texts[16][15],0,COLOUR_GREEN);
	return 1;
}

public AmmunationCommandHandler(playerid,text[]) // process player commands
{
	if(!IsPlayerRegistered(playerid)) return 0; // non registered players dont use weapon commands
	new cmd[20],idx;
	set(cmd,strcharsplit(text, idx,strchar(" ")));
	if (strlen(cmd) == 0) return 0;
	if(strcomp(cmd,"/weapons",true) == 1)
	{
		SendPlayerOwnedWeapons(playerid);
		return 1;
	}
	if((strcomp(cmd,"/wl",true) == 1) || (strcomp(cmd,"/weaponlist",true) == 1))
	{
		if(!IsPlayerAtAmmunation(playerid))
		{
			SendPlayerFormattedText(playerid,lang_texts[16][16],0,COLOUR_RED);
			return 1;
		}
		SendPlayerVendorWeapons(playerid);
		return 1;
	}
	if((strcomp(cmd,"/wb",true) == 1) || (strcomp(cmd,"/weaponbuy",true) == 1))
	{
		if(!IsPlayerAtAmmunation(playerid))
		{
			SendPlayerFormattedText(playerid,lang_texts[16][17],0,COLOUR_RED);
			return 1;
		}
		set(cmd,strcharsplit(text, idx,strchar(" ")));
		if(strlen(cmd) == 0)
		{
			SendPlayerVendorWeapons(playerid);
			return 1;
		}
		new weaponid = strval(cmd);
		if(weaponid <= 0)
		{
			SendPlayerFormattedText(playerid,lang_texts[16][19],0,COLOUR_RED);
			return 1;
		}
		set(cmd,strcharsplit(text, idx,strchar(" ")));
		new bullets;
		if(strlen(cmd) == 0) bullets = 1;
		else bullets = strval(cmd);
		if(bullets < 0)
		{
			SendPlayerFormattedText(playerid,lang_texts[16][20],0,COLOUR_RED);
			return 1;
		}
		BuyWeapon(playerid,weaponid,bullets);
		return 1;
	}

	if(strcomp(cmd,"/weapon",true) == 1)
	{
		set(cmd,strcharsplit(text, idx,strchar(" ")));

		if(strcomp(cmd, "help", true) == 1)
		{
			SendPlayerFormattedText(playerid,  lang_texts[16][21]  , 0,COLOUR_RED);
			return 1;
		}

		if(strcomp(cmd,"list",true) == 1)
		{
			if(!IsPlayerAtAmmunation(playerid))
			{
				SendPlayerFormattedText(playerid,lang_texts[16][22],0,COLOUR_RED);
				return 1;
			}
			SendPlayerVendorWeapons(playerid);
			return 1;
		}
		if(strcomp(cmd,"buy",true) == 1)
		{
			if(!IsPlayerAtAmmunation(playerid))
			{
				SendPlayerFormattedText(playerid,lang_texts[16][23],0,COLOUR_RED);
				return 1;
			}
			set(cmd,strcharsplit(text, idx,strchar(" ")));
			if (strlen(cmd) == 0)
			{
				SendPlayerVendorWeapons(playerid);
				return 1;
			}
			new weaponid = strval(cmd);
			if(weaponid <= 0)
			{
				SendPlayerFormattedText(playerid,lang_texts[16][25],0,COLOUR_RED);
				return 1;
			}
			new bullets;
			set(cmd,strcharsplit(text, idx,strchar(" ")));
			if(strlen(cmd) == 0) bullets = 1;
			else bullets = strval(cmd);
			if(bullets < 0)
			{
				SendPlayerFormattedText(playerid,lang_texts[16][26],0,COLOUR_RED);
				return 1;
			}
			BuyWeapon(playerid,weaponid,bullets);
			return 1;
		}
	}
	return 0;
}

public WeaponMenuInit()
{
	new cost[256],costt;
	WeaponMenu = CreateMenu("Ammu-nation",1,50.0,200.0,100.0,200.0);
	AddMenuItem(WeaponMenu,0,"Pistols");
	AddMenuItem(WeaponMenu,0,"Micro SMG");
	AddMenuItem(WeaponMenu,0,"Shotguns");
	AddMenuItem(WeaponMenu,0,"Armor");
	AddMenuItem(WeaponMenu,0,"Assault");
	
	PistolMenu = CreateMenu("Pistols",2,100.0,200.0,100.0,200.0);
	SetMenuColumnHeader(PistolMenu,0,"Weapon");
	SetMenuColumnHeader(PistolMenu,1,"Cost");
	AddMenuItem(PistolMenu,0,"9mm");
	costt = GetWeaponCost(WEAPON_COLT45)*pistol_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(PistolMenu,1,cost);
	AddMenuItem(PistolMenu,0,"9mm silenced");
	costt = GetWeaponCost(WEAPON_SILENCED)*pistol_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(PistolMenu,1,cost);
	AddMenuItem(PistolMenu,0,"Deagle");
	costt = GetWeaponCost(WEAPON_DEAGLE)*pistol_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(PistolMenu,1,cost);
	
	MicroSMGMenu = CreateMenu("Micro-SMG",2,100.0,200.0,100.0,200.0);
	SetMenuColumnHeader(MicroSMGMenu,0,"Weapon");
	SetMenuColumnHeader(MicroSMGMenu,1,"Cost");
	AddMenuItem(MicroSMGMenu,0,"Uzi");
	costt = GetWeaponCost(WEAPON_SHOTGUN)*smg_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(MicroSMGMenu,1,cost);
	AddMenuItem(MicroSMGMenu,0,"MP5");
	costt = GetWeaponCost(WEAPON_SAWEDOFF)*smg_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(MicroSMGMenu,1,cost);
	AddMenuItem(MicroSMGMenu,0,"Tec9");
	costt = GetWeaponCost(WEAPON_SHOTGSPA)*smg_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(MicroSMGMenu,1,cost);
	
	ShotgunsMenu = CreateMenu("Shotguns",2,100.0,200.0,100.0,200.0);
	SetMenuColumnHeader(ShotgunsMenu,0,"Weapon");
	SetMenuColumnHeader(ShotgunsMenu,1,"Cost");
	AddMenuItem(ShotgunsMenu,0,"Shotgun");
	costt = GetWeaponCost(WEAPON_SHOTGUN)*shotgun_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(ShotgunsMenu,1,cost);
	AddMenuItem(ShotgunsMenu,0,"Sawedoff");
	costt = GetWeaponCost(WEAPON_SAWEDOFF)*shotgun_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(ShotgunsMenu,1,cost);
	AddMenuItem(ShotgunsMenu,0,"Shotgspa");
	costt = GetWeaponCost(WEAPON_SHOTGSPA)*shotgun_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(ShotgunsMenu,1,cost);
	
	AssaultMenu = CreateMenu("Assault",2,100.0,200.0,50.0,100.0);
	SetMenuColumnHeader(AssaultMenu,0,"Weapon");
	SetMenuColumnHeader(AssaultMenu,1,"Cost");
	AddMenuItem(AssaultMenu,0,"Ak47");
	costt = GetWeaponCost(WEAPON_AK47)*assault_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(AssaultMenu,1,cost);
	AddMenuItem(AssaultMenu,0,"M4");
	costt = GetWeaponCost(WEAPON_M4)*assault_bullets;
	format(cost,sizeof(cost),"%d",costt);
	AddMenuItem(AssaultMenu,1,cost);
}
		
public WeaponsMenu(playerid,row)
{
	new Menu:Current = GetPlayerMenu(playerid),bullets;
	if(Current == WeaponMenu) 
	{
		switch(row) 
		{
			case 0: ShowMenuForPlayer(PistolMenu,playerid);
			case 1: ShowMenuForPlayer(MicroSMGMenu,playerid);
			case 2: ShowMenuForPlayer(ShotgunsMenu,playerid);
			case 3: 
			{
				SetPlayerArmour(playerid,100);
				ShowMenuForPlayer(WeaponMenu,playerid);
			}
			case 4: ShowMenuForPlayer(AssaultMenu,playerid);
		}
	}
	if(Current == PistolMenu)
	{
		bullets = 14;
		switch(row) 
		{
			case 0: 
			{
				BuyWeapon(playerid,22,bullets);
				ShowMenuForPlayer(PistolMenu,playerid);
			}
			case 1: 
			{
				BuyWeapon(playerid,23,bullets);
				ShowMenuForPlayer(PistolMenu,playerid);
			}
			case 2: 
			{
				BuyWeapon(playerid,24,bullets);
				ShowMenuForPlayer(PistolMenu,playerid);
			}
		}
	}
	if(Current == MicroSMGMenu)
	{
		bullets = 100;
		switch(row) 
		{
			case 0: 
			{
				BuyWeapon(playerid,28,bullets);
				ShowMenuForPlayer(MicroSMGMenu,playerid);
			}
			case 1: 
			{
				BuyWeapon(playerid,29,bullets);
				ShowMenuForPlayer(MicroSMGMenu,playerid);
			}
			case 2: 
			{
				BuyWeapon(playerid,32,bullets);
				ShowMenuForPlayer(MicroSMGMenu,playerid);
			}
		}
	}
	if(Current == ShotgunsMenu)
	{
		bullets = 10;
		switch(row) 
		{
			case 0: 
			{
				BuyWeapon(playerid,25,bullets);
				ShowMenuForPlayer(ShotgunsMenu,playerid);
			}
			case 1: 
			{
				BuyWeapon(playerid,26,bullets);
				ShowMenuForPlayer(ShotgunsMenu,playerid);
			}
			case 2: 
			{
				BuyWeapon(playerid,27,bullets);
				ShowMenuForPlayer(ShotgunsMenu,playerid);
			}
		}
	}
	if(Current == AssaultMenu)
	{
		bullets = 30;
		switch(row) 
		{
			case 0: 
			{
				BuyWeapon(playerid,30,bullets);
				ShowMenuForPlayer(AssaultMenu,playerid);
			}
			case 1: 
			{
				BuyWeapon(playerid,31,bullets);
				ShowMenuForPlayer(AssaultMenu,playerid);
			}
		}
	}
	return 1;
}

public WeaponMenuExit(playerid)
{
	new Menu:tmpMenu = GetPlayerMenu(playerid);
	if(tmpMenu != WeaponMenu) ShowMenuForPlayer(WeaponMenu,playerid);
	else 
	{
		PlayerMenu[playerid] = 0;
		HideMenuForPlayer(tmpMenu,playerid);
		TogglePlayerControllable(playerid,true);
	}
	return 1;
}
