/*
Project Name:	San Andreas: Multiplayer: Grand Theft Online.

Date Created:		12 August 2006
Date start edit: 	5 November 2009(by Russian Scripter's)

Current version: GTO 0.6.1a
SA-MP Versions:	0.3a
*/
#include <a_samp>							// samp
#include "base"								// holds base script values
#include "utils\gtoutils"					// misc used utils
#include "utils\dini"						// db handler
#include "utils\dutils"						// more used tools
#include "lang"
#include "account"							// account handler
#include "player"							// holds player values
#include "weapons"							// weapons and ammunation shop
#include "vehicles"							// vehicles
#include "world"							// functions for zone, location, world, etc
#include "commandhandler"					// command handler
#include "gang"								// gang handler
#include "housing"							// housing handler
#include "business"							// business handler
#include "logging"							// logging handler
#include "race"								// race handler, manages and runs all rasces
#include "deathmatch"						// deathmatch handler
#include "bank"								// bank money to keep it on death
#include "payday" 							// pay players money based on level
#include "groundhold"						// hold ground to gain money, pirate ship, etc
#include "admin\admin_commands"				// admin commands
#include "admin\admin_commands_race"		// admin commands for race creation/minipulation
#include "admin\admin_commands_dm"			// admin commands for deathmatch creation/minipulation
#include "admin\admin_commands_sys"
#include "admin\adm_commands"
#include "admin\mod_commands"
#include "StIcon"
#tryinclude "misc\mapicon"
#tryinclude "click"
#tryinclude "FightStyle"
// Races
#tryinclude "races\race_monstertruck"		// Race: Monstertruck Madness
#tryinclude "races\race_thestrip"			// Race: Burnin Down The Strip. - Just a strait sprint down the strip and back
#tryinclude "races\race_riversiderun"		// Race: Riverside Run. - Beat the clock down a riverside dirt track.
#tryinclude "races\race_fleethecity"		// Race: Flee The City. - race to air strip
#tryinclude "races\race_lostinsmoke"		// Race: Lost in Smoke - a quick race around the city.
#tryinclude "races\race_backstreetbang"		// Race: Backstreet bang
#tryinclude "races\race_flyingfree"			// Race: Flying Free
#tryinclude "races\race_murderhorn"			// Race: Murderhorn - by |Insane|
#tryinclude "races\race_roundwego"			// Race: Airport Round We Go - by |Insane|
#tryinclude "races\race_striptease"			// Race: Strip Tease - by |Insane|
#tryinclude "races\race_countrycruise"		// Race: Countryside cruise
#tryinclude "races\race_thegrove"			// Race: Tearin Up The Grove
#tryinclude "races\race_mullholland"		// Race: Mullholland Getaway
#tryinclude "races\race_lv_julius"   		// RACE: BIG CIRCLE OF 3
#tryinclude "races\race_ls_trailer1"        // RACE: Trailers race
#tryinclude "races\race_sf_fuckinwood1"
#tryinclude "races\race_ls_majestic1"

// Deathmatches
#tryinclude "deathmatches\dm_air"			// Deathmatch - Base Jump
#tryinclude "deathmatches\dm_area51"		// Deathmatch - Area 51
#tryinclude "deathmatches\dm_badandugly"	// Deathmatch - The Bad and the Ugly
#tryinclude "deathmatches\dm_bluemountains"	// Deathmatch - Blue Mountains
#tryinclude "deathmatches\dm_cargoship"		// Deathmatch - Cargo Ship
#tryinclude "deathmatches\dm_dildo"			// Deathmatch - Dildo Farm Revenge
#tryinclude "deathmatches\dm_mbase"			// Deathmatch - Millitary Base
#tryinclude "deathmatches\dm_minigunmadness"// Deathmatch - Minigun Madness
#tryinclude "deathmatches\dm_poolday"		// Deathmatch - fy_poolday
#tryinclude "deathmatches\dm_usnavy"		// Deathmatch - The US Navy

main() 
{	// CREDITS NOT DELETE !!!!!!!!!!!!!!!!!
	print(" ");
	print(" ");
	print("\n-----------------------------------------------------------\n");
	printf("Running GTO %s\n",VERSION);
	print("_____________________________________________________________\n");
	print("Created by: Iain Gilbert (Bogart)\nContinued by: Peter Steenbergen (j1nx)\n\t\tRobin Kikkert (Dejavu)\n\t\tLajos Pacsek (asturel)");
	print("\t\tDmitry Frolov (FP)\nGTO-Rus Team(): GhostTT, heufix, Elbi, ZiGGi");
	print("_____________________________________________________________\n");
	print("Translated to Russian by Dmitry Borisoff (Beginner)");
	print("Visit us at http://gto.sa-mp.ws/");
	print("\n------------------------------------------------------------\n");
}   // CREDITS NOT DELETE !!!!!!!!!!!!!!!!!

public OnGameModeInit()
{
	new gamemode[MAX_NAME];
	format(gamemode,sizeof(gamemode),"GTO %s",VERSION);
	SetGameModeText(gamemode);
	// Initialize everything that needs it
	LoggingInit();
	BaseLoadConfig();
	AccountLoadConfig();
	PlayerLoadConfig();
	GangLoadConfig();
	PaydayLoadConfig();
	LoggingLoadConfig();
	WeaponLoadAll();
	LoadVehicles();
	RaceLoadAll();
	DeathmatchLoadAll();
	HousesLoadAll();
	BusinessLoadAll();
	AmmunationInit();
	BankInit();
	GroundholdInit();
	BusinessInit();
	HousesInit();
	LanguageInit();
	MapIconsInit();
	FightStyleInit();
	WeaponMenuInit();
	//EnableTirePopping(1);
	//EnableZoneNames(1);
	UsePlayerPedAnims();
	AllowAdminTeleport(1);
	ShowPlayerMarkers(1);
	ShowNameTags(1);
	
	// Races
	race_thestrip_init();
	race_riversiderun_init();
	race_fleethecity_init();
	race_lostinsmoke_init();
	race_backstreetbang_init();
	race_flyingfree_init();
	race_murderhorn_init();
	race_roundwego_init();
	race_striptease_init();
	race_monstertruck_init();
	race_countrycruise_init();
	race_thegrove_init();
	race_mullholland_init();
	race_lv_julius_init();
	race_ls_trailer1_init();
	race_sf_fuckinwood1_init();
	race_ls_majestic1_init();
	
	// Deathmatches
	dm_air_init();
	dm_area51_init();
	dm_badandugly_init();
	dm_bluemountains_init();
	dm_cargoship_init();
	dm_dildo_init();
	dm_mbase_init();
	dm_minigunmadness_init();
	dm_poolday_init();
	dm_usnavy_init();
	printf("SERVER: Racing, DM and Taxi scripts init");
	
	#tryinclude "misc\pickups"    //new pickups
	#tryinclude "misc\objects"    //new objects
	printf("SERVER: New Objects and Pickups init");
	
	new hour,minute,second;
	gettime(hour,minute,second);
	WorldTime = hour;
	SetWorldTime(WorldTime);
	printf("SERVER: Worldtime set as %d",WorldTime);
	SetWeather(10);
	SetTimer("SyncPlayers",PLAYER_SYNC_DELAY, 1);
	SetTimer("PlayerHealthRegen",HEALTH_REGEN_SPEED, 1);
	SetTimer("TextScroller",TEXT_SCROLL_SPEED,1);
	SetTimer("WorldSave",WorldSaveDelay, 1);
	SetTimer("SyncActiveCP",2600,1);
	SetTimer("PayDay",PayDayDelay,1);
	SetTimer("CheckAllGround",GROUNDHOLD_DELAY,1);
	SetTimer("TurnAround",TurnAroundDelay,1);
	SetTimer("HouseKeepUp",HOUSE_DELAY,1);
	SetTimer("OneSecTimer",1000,1); // 1 second
	SetTimer("OneMinuteTimer",60000,1); // 1 minute
	SpawnWorld();
	if(VerboseSave == 1 || VerboseSave == -1)
	{
		WorldSave();
		if(VerboseSave == -1) VerboseSave = 0;
	}
	printf("SERVER: %s initialization complete. [%d:%02d]",gamemode,hour,minute);
	new logstring[MAX_STRING];
	format(logstring,sizeof(logstring),"SERVER: %s initialization complete. ",gamemode);
	WriteLog(logstring);
	return 1;
}

public OnPlayerConnect(playerid)
{
    if(playerid == INVALID_PLAYER_ID || IsPlayerNPC(playerid)) return 1;
	player_Connect(playerid);
   	AccountConnect(playerid);
	MapIconFunc();
	return 1;
}

public OnPlayerDisconnect(playerid,reason)
{
	if(playerid == INVALID_PLAYER_ID || IsPlayerNPC(playerid)) return 1;
	player_Disconnect(playerid,reason);
	WorldSave();
	return 1;
}

public OnDialogResponse(playerid, dialogid, response, listitem, inputtext[])
{
	AccountDialog(playerid,dialogid,response,listitem,inputtext);
	HousesDialog(playerid,dialogid,response,listitem,inputtext);
	OnBusinessDialog(playerid,dialogid,response,listitem,inputtext);
	PlayerClickResponse(playerid,dialogid,response,listitem,inputtext);
	BankDialog(playerid,dialogid,response,listitem,inputtext);
	OnFightDialog(playerid, dialogid, response, listitem, inputtext);
	return 1;
}

public OnPlayerClickPlayer(playerid, clickedplayerid, source)
{
	ClickPlayer(playerid, clickedplayerid);
	return 1;
}

public OnPlayerPickUpPickup(playerid,pickupid)
{
    BankPickUp(playerid,pickupid);
    HousesPickUp(playerid,pickupid);
    BusinessPickUp(playerid,pickupid);
	WeaponPickup(playerid,pickupid);
    FightStylePickUp(playerid,pickupid);
    return 1;
}

public OnPlayerEnterCheckpoint(playerid)
{
	OnPlayerEnterAmmoCheckpoint(playerid);
	OnPlayerEnterRaceCheckpoint(playerid);
	OnPlayerEnterDMCheckpoint(playerid);
}

public OnPlayerDeath(playerid, killerid, reason)
{
	new logstring[256];
	if(!IsPlayerConnected(playerid) || IsPlayerNPC(playerid)) return 1;
	if(killerid == INVALID_PLAYER_ID) format(logstring, sizeof (logstring), "player: %d: %s: has died > Reason: (%d)",playerid,oGetPlayerName(playerid),reason);
	else format(logstring, sizeof (logstring), "player: %d: %s: has killed player %s(%d)> Reason: (%d)",killerid,oGetPlayerName(killerid),oGetPlayerName(playerid),playerid,reason);
	WriteLog(logstring);
	SendDeathMessage(killerid,playerid,reason);
	if(!IsPlayerInAnyDM(playerid))
	{
		PlayerDeath(playerid, killerid, reason);
	//	DropPlayerWeapons(playerid);
		PlayCrimeReportForPlayer(killerid,killerid,random(18)+3);
		PlayCrimeReportForPlayer(playerid,killerid,random(18)+3);
 	}
	else OnPlayerDMDeath(playerid,killerid);
	if(killerid == INVALID_PLAYER_ID) return 1;
	if(!IsPlayerInAnyDM(playerid)) PlayerKill(killerid, playerid, reason);
	else OnPlayerDMKill(killerid,playerid,reason);
	return 1;
}

public OnPlayerSpawn(playerid)
{
	if(!IsPlayerConnected(playerid)) return 1;
	SetPlayerSkin(playerid,Player[playerid][SkinModel]);
	FOnPlayerSpawn(playerid);
	if(Player[playerid][Jailed] == 1)
	{
		SetPlayerInterior(playerid,6);
		SetPlayerPos(playerid,265.1273,77.6823,1001.0391);
	    SetPlayerFacingAngle(playerid,0);
	    SetPlayerWantedLevel(playerid, 6);
		SetPlayerArmour(playerid, 0);
		SetPlayerHealth(playerid, 10);
		ResetPlayerMoney(playerid);
		ResetPlayerWeapons(playerid);
		PlayerPlaySound(playerid,1082,198.3797,160.8905,1003.0300);
	}
	if(Player[playerid][MuteTime] != 0)
	{
		SendPlayerFormattedText(playerid,lang_texts[1][14], 0,COLOUR_RED);
		SetPlayerWantedLevel(playerid, 3);
	}
	new dmid = GetPlayerDM(playerid);
	if(dmid == INVALID_DM_ID || DMPlayerStats[playerid][dm_player_active] == 0) player_Spawn(playerid);
	else DMPlayerSpawn(playerid,dmid);
	SetPlayerColor(playerid,PlayerGangColour(playerid));
	return 1;
}

public OnPlayerRequestClass(playerid, classid)
{
	Player[playerid][SkinModel] = GetPlayerSkin(playerid);
	if(City[playerid] == 0)
	{
		SetPlayerInterior(playerid,11);
		SetPlayerPos(playerid,508.7362,-87.4335,998.9609);
		SetPlayerFacingAngle(playerid,0.0);
    	SetPlayerCameraPos(playerid,508.7362,-83.4335,998.9609);
		SetPlayerCameraLookAt(playerid,508.7362,-87.4335,998.9609);
	}
	else if(City[playerid] == 1)
	{
		SetPlayerInterior(playerid,3);
		SetPlayerPos(playerid,-2673.8381,1399.7424,918.3516);
		SetPlayerFacingAngle(playerid,181.0);
    	SetPlayerCameraPos(playerid,-2673.2776,1394.3859,918.3516);
		SetPlayerCameraLookAt(playerid,-2673.8381,1399.7424,918.3516);
	}
	else if(City[playerid] == 2)
	{
		SetPlayerInterior(playerid,3);
		SetPlayerPos(playerid,349.0453,193.2271,1014.1797);
		SetPlayerFacingAngle(playerid,286.25);
    	SetPlayerCameraPos(playerid,352.9164,194.5702,1014.1875);
		SetPlayerCameraLookAt(playerid,349.0453,193.2271,1014.1797);
	}
	return 1;
}

public OnPlayerCommandText(playerid,cmdtext[])
{
	CommandHandler(playerid,cmdtext);
	AccountCommandHandler(playerid,cmdtext);
	GangCommandHandler(playerid,cmdtext);
	AmmunationCommandHandler(playerid,cmdtext);
	BankCommandHandler(playerid,cmdtext);
	RaceCommandHandler(playerid,cmdtext);
	AdminRaceCommandHandler(playerid,cmdtext);
	AdminCommandHandler(playerid,cmdtext);  //rcon admins
	AdminCommandHandlerSys(playerid,cmdtext);   //SYSTEM
	DMCommandHandler(playerid,cmdtext);
	AdminDMCommandHandler(playerid,cmdtext);
	AdmCommandHandler(playerid,cmdtext);    //admins
	ModCommandHandler(playerid,cmdtext);    //moderators
	BusinessCommandHandler(playerid,cmdtext);
	HousesCommandHandler(playerid,cmdtext);
	CarsCommandHandler(playerid,cmdtext);
	FightCommands(playerid,cmdtext);
	return 1;
}

public OnPlayerText(playerid, text[])
{
	new logstring[256],string[MAX_STRING],gangmessage[MAX_STRING];
	if(text[0] == '!')
	{
		if((PlayerGangid[playerid] == 0) || (Player[playerid][MuteTime] != 0))    // 
		{
			SendPlayerFormattedText(playerid,lang_texts[1][14], 0,COLOUR_RED);
			return 0;
		}
		strmid(gangmessage,text,1,strlen(text));
		if(!strlen(gangmessage)) return 1;
		format(gangmessage, sizeof(gangmessage), "%s(%d) : %s", oGetPlayerName(playerid), playerid, gangmessage);
		SendGangMessage(PlayerGangid[playerid],gangmessage,COLOUR_GANG_CHAT);
		format(logstring, sizeof (logstring), "Player: %s [ID: %d]: <GANG CHAT>:   %s",oGetPlayerName(playerid),playerid,text);
		WriteChatLog(logstring);
		return 0;
	}
	if(text[0] == '@')
	{
		AdminSpecialCommandHandler(playerid,text);
		format(logstring, sizeof (logstring), "Player: %s [ID: %d]: <ADMIN TALK>:   %s",oGetPlayerName(playerid),playerid,text);
		WriteChatLog(logstring);
		return 0;
	}
	if(text[0] == '#')
	{
		ModSpecialCommandHandler(playerid,text);
		format(logstring, sizeof (logstring), "Player: %s [ID: %d]: <MODERATOR TALK>:   %s",oGetPlayerName(playerid),playerid,text);
		WriteChatLog(logstring);
		return 0;
	}
	else if(Player[playerid][MuteTime] != 0)  //
	{
		SendPlayerFormattedText(playerid,lang_texts[1][14],0,COLOUR_RED);
		return 0;
	}
	format(logstring,sizeof(logstring),"Player: %s [ID: %d]:   %s",oGetPlayerName(playerid),playerid,text);
	WriteChatLog(logstring);
	format(string, sizeof(string),"[%d]: %s", playerid, text);
	SendPlayerMessageToAll(playerid, string);
	return 0;
}

public WeatherUpdate()
{
	if(sysweath != 1) return 1;
	new rand = random(19);
	SetWeather(rand);
	printf("SERVER: Weather set to %d",rand);
	return 1;
}

public OnPlayerUpdate(playerid)
{
    PlayerUpdate(playerid);
	return 1;
}

public OnPlayerKeyStateChange(playerid,newkeys,oldkeys)
{
	HouseKey(playerid,newkeys,oldkeys);
	return 1;
}

public OnPlayerSelectedMenuRow(playerid,row)
{
	WeaponsMenu(playerid,row);
	return 1;
}

public OnPlayerExitedMenu(playerid)
{
	WeaponMenuExit(playerid);
	return 1;
}
